<?php

namespace App\Console\Commands;

use App\Models\TreeGenealogyNested;
use App\Models\User;
use Illuminate\Console\Command;

class MakeAsRoot extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'genealogy:makeAsRoot {user_id}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $user_id = $this->argument('user_id');

        $user = User::findOrFail($user_id);

        $node = TreeGenealogyNested::find($user_id);

        if($node){
            $this->line('Moved to root');
            return $node->saveAsRoot();
        }

        $node = new \App\Models\TreeGenealogyNested;
        $node->id = $user_id;
        $node->save();

        $this->line('Saved as root');
    }
}
