<?php

namespace App\Console\Commands;

use App\Facades\MailManager;
use App\Models\Packages;
use App\Models\User;
use App\Models\UserAddresses;
use App\Models\UsersBtcAddresses;
use App\Models\UsersPackages;
use App\Models\UsersUsdAddresses;
use Illuminate\Console\Command;

class SetNonCommissionPackageManually extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'setnoncommissionpackage:manual {--userId=}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $userId = $this->option('userId');



        $package = Packages::where('id', 5)->first();
        $user = User::findOrFail($userId);
        $fee = 0;


        $new_package                = new \App\Models\UsersPackages;
        $new_package->user_id       = $userId;
        $new_package->package_id    = $package->id;
        $new_package->status        = 1;
        $new_package->save();

        $new_transaction                = new \App\Models\Transactions;
        $new_transaction->processor_id  = 1;
        $new_transaction->user_id       = $userId;
        $new_transaction->type          = 1;
        $new_transaction->amount        = $package->price;
        $new_transaction->translateOrNew('en')->note = 'Package ID: #' . $new_package->id . ', Type: ' . $package->name;
        $new_transaction->translateOrNew('cn')->note = '套餐ID: #' . $new_package->id . ', 类型: ' . $package->name;
        $new_transaction->status        = 1;

        if( $new_transaction->save() ) {
            dispatch_now( new \App\Jobs\SetNonCommssionPackage( $new_package->id ) );

            MailManager::send('packages.new-package', 'New Package Purchase', [
                'id' => $new_package->id,
                'package_name' => $package->name,
                'amount' => $package->price
            ], $user);
        }
    }
}
