<?php

namespace App\Console\Commands;

use App\Facades\MailManager;
use App\Models\UserAddresses;
use App\Models\UsersBtcAddresses;
use App\Models\UsersPackages;
use App\Models\UsersUsdAddresses;
use Illuminate\Console\Command;

class SetPackageManually extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'setpackage:manual {--address=}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $address = $this->option('address');

        $userAddress = UserAddresses::where('address', $address)->withTrashed()->first();
        $userAddress->received = $userAddress->amount;

        $userAddress->save();


        $package = $userAddress->package;
        $user = $userAddress->user;
        $fee = 0;

        $transactionDeposit                 = new \App\Models\Transactions;
        $transactionDeposit->processor_id   = 1;
        $transactionDeposit->user_id        = $userAddress->user_id;
        $transactionDeposit->type           = 6;
        $transactionDeposit->fee            = $fee;
        $transactionDeposit->amount         = $package->price;


        $transactionDeposit->translateOrNew('en')->note           = 'Deposit via PEAK (USD) - ' . $userAddress->amount;
        $transactionDeposit->translateOrNew('cn')->note           = '存款美元 - ' . $userAddress->amount;

        $transactionDeposit->status         = 1;
        $transactionDeposit->save();

        $userAddress->delete();

        $new_package                = new \App\Models\UsersPackages;
        $new_package->user_id       = $userAddress->user_id;
        $new_package->package_id    = $package->id;
        $new_package->status        = 1;
        $new_package->save();

        $new_transaction                = new \App\Models\Transactions;
        $new_transaction->processor_id  = 1;
        $new_transaction->user_id       = $userAddress->user_id;
        $new_transaction->type          = 1;
        $new_transaction->amount        = $package->price;
        $new_transaction->translateOrNew('en')->note = 'Package ID: #' . $new_package->id . ', Type: ' . $package->name;
        $new_transaction->translateOrNew('cn')->note = '套餐ID: #' . $new_package->id . ', 类型: ' . $package->name;
        $new_transaction->status        = 1;

        if( $new_transaction->save() ) {
            dispatch_now( new \App\Jobs\SetPackage( $new_package->id ) );

            MailManager::send('packages.new-package', 'New Package Purchase', [
                'id' => $new_package->id,
                'package_name' => $package->name,
                'amount' => $package->price
            ], $user);
        }
    }
}
