<?php

namespace App\Console\Commands;

use App\Facades\WCIApi;
use App\Models\WCILastPrices;
use Illuminate\Console\Command;

class UpdateWCILastPrices extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'wci:update-last-prices';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $markets = [
            "CPC/USD" => WCIApi::getLastCpcUsd(),
        ];

        foreach($markets as $key => $value){
            WCILastPrices::firstOrCreate(['market' => $key])->update(["price" => $value]);
        }

    }
}
