<?php

namespace App\Console;

use App\Console\Commands\MakeAsRoot;
use App\Console\Commands\SetNonCommissionPackageManually;
use App\Console\Commands\SetPackageManually;
use App\Console\Commands\UpdateWCILastPrices;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        \App\Console\Commands\AuctionValidation::class,
        \App\Console\Commands\AuctionBidButler::class,
        \App\Console\Commands\AutoAuctionSimulation::class,
        \App\Console\Commands\AutoBid::class,
        \App\Console\Commands\AuctionGiftCards::class,
        UpdateWCILastPrices::class,
        SetPackageManually::class,
        SetNonCommissionPackageManually::class,
        MakeAsRoot::class

    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
        //$schedule->command('auction:validation')->everyMinute();
        $schedule->command('auction:autobid')->everyFiveMinutes();
        $schedule->command('wci:update-last-prices')->everyFiveMinutes()->appendOutputTo('/var/www/dyeus/cron.log');;

    }

    /**
     * Register the Closure based commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        require base_path('routes/console.php');
    }
}
