<?php

if ( ! function_exists('trim_text'))
{
	function trim_text($input, $length, $ellipses = true, $strip_html = true) {
    if ($strip_html) {
      $input = strip_tags($input);
    }
  
    if (strlen($input) <= $length) {
      return $input;
    }
  
    $last_space = strrpos(substr($input, 0, $length), ' ');
    $trimmed_text = substr($input, 0, $last_space);
    
    if ($ellipses) {
      $trimmed_text .= '...';
    }
  
    return $trimmed_text;
	}
}

if ( ! function_exists('random_num'))
{
  function random_num($min = 0, $max = 9999999, $seed = 0)
  {
    if ($seed == 0) {
      $seed = mt_rand();
    }
    
    $seed = abs(intval($seed)) % 9999999 + 1;
    $seed = ($seed * 125) % 2796203;
    return $seed % ($max - $min + 1) + $min;
  }
}

if ( ! function_exists('unique_num'))
{
  function unique_num($length = 10)
  {
    return substr(number_format(time() * rand(),0,'',''),0,$length);
  }
}

if ( ! function_exists('changeForeignLetters'))
{
  function changeForeignLetters($string) {
    $characters = array('á' => 'a', 'Á' => 'A', 'é' => 'e', 'É' => 'E', 'ű' => 'u','Ű' => 'U','ő' => 'o','Ő' => 'O','ú' => 'U','ö' => 'o','Ö' => 'O','ü' => 'u','Ü' => 'U','ó' => 'o','Ó' => 'O','í' => 'i','Í' => 'I',' ' => '_', '(' => '', ')' => '', '!' => '', '?' => '', '.' => '', ',' => '');
      $string = str_replace(array_keys($characters), array_values($characters), $string);
      return $string;
  }
}

if ( ! function_exists('explode_string'))
{
  function explode_string($input, $delimiter, $glue = ' ') {
    return implode($glue, explode($delimiter, $input));
  }
}

if( ! function_exists('pretty_text'))
{
  function pretty_text( $text ) {
    $characters = array('_' => ' ');
    $text = str_replace(array_keys($characters), array_values($characters), $text);
    return ucfirst( $text );
  }
}