<?php
namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Auth;

class AdminController extends Controller {

	public function __construct()
	{
		parent::__construct();

		$this->middleware(function ($request, $next) {

    		$this->user = Auth::user();
    		view()->share('user', $this->user);

			if( $this->user->hasRole('admin') ) {

			    view()->share('counters', [
			    	'SupportTicketsActive' => \App\Models\Support::active()->count(),
			    	'pendingDeposits' => \App\Models\Transactions::where('status', 0)->whereIn('type', [1,2,3,4,5,6])->count(),
			    	'pendingCashouts' => \App\Models\Transactions::where('status', 0)->whereIn('type', [7,8,9,10,11])->count(),
			    	'pendingPrincipal' => \App\Models\UsersPackages::where('status', 2)->count(),
			    	'pendingBanks' => \App\Models\UsersProcessors::where('processor_id', 1)->where('status', 0)->where('bank_details_id', '!=', NULL)->count(),
			    	'pendingGatewayAccounts' => \App\Models\UsersProcessors::where('processor_id', '!=', 1)->where('processor_id', '!=', 4)->where('status', 0)->count()
			    ]);

			} elseif( $this->user->hasRole('support') ) {
					view()->share('counters', [
						'SupportTicketsActive', \App\Models\Support::active()->assigned($this->user->id)->count()
					]);
			}

            view()->share('bodyClass', $this->bodyClass);

            return $next( $request );
        });
	}
}
