<?php

namespace App\Http\Controllers\Admin\Ajax;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

use Auth;

class AjaxController extends BaseController
{
   use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
	
	protected $results = ['error' => false, 'data' => []];

	public function __construct()
	{
		if( Auth::check() ) $this->user = Auth::user();
	}

	public function response( $response = false ) {
		if( $response ) $this->results = array_merge($this->results, $response);

		return response()->json( $this->results ); 
	}

	public function responseTable( $response ) {
		return response()->json( $response ); 
	}
}