<?php 
namespace App\Http\Controllers\Admin\Ajax;

use \App\Models\Loans;
use DB, Config, Input;

class EmailTemplatesController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postTemplatesTable()
	{
		$order = Input::get('order', false);
		$start = Input::get('start', 0);
		$length = Input::get('length', 25);

		$start = ( $start < 1 ) ? 0 : $start;
    	$length = ( $length < 1 ) ? 25 : $length;

		if ( $order && !empty( $order ) ) {
      		$_order = array_pop($order);
      		$dir = $_order['dir'];

		    switch ( $_order['column'] ) {
		      	case 0:
		        	$order_by = 'id';
		          break;
		        case 1:
		        	$order_by = 'title';
		          break;
		        case 4:
		          $order_by = 'created_at';
		          break;
		        default: 
		         	$dir = 'asc';
		         	$order_by = 'id';
		        break;
		    }

		    $emailTemplates = \App\Models\Admin\EmailTemplates::orderBy( $order_by, $dir );
		}
		

		$emailTemplates_total = $emailTemplates->count();
  	$emailTemplates_count = $emailTemplates->skip( $start )->take( $length )->count();
  	$emailTemplates = $emailTemplates->skip( $start )->take( $length )->get();

  	foreach( $emailTemplates as $et ) {
  		$et->content = trim_text(str_replace(['@extends("emails.template")', '@section("content")', "@stop"], ['', '', ''], $et->content), 100);
  	}

  	$response = ['draw' => Input::get('draw', 1), 'data' => $emailTemplates, 'recordsFiltered' => $emailTemplates_count, 'recordsTotal' => $emailTemplates_total];

    return $this->responseTable( $response );
	}

	public function postDelete()
	{
		$id = Input::get('id', null);
		
		if( is_null( $template = \App\Models\Admin\EmailTemplates::where('id', $id)->first() ) )
			return response()->json(false);

		if( $template->path == NULL ) {

			if( $template->path !== NULL ) {
				$view_path = base_path('/resources/views/emails/');
				$view_name = str_replace('.', '/', $template->path);
				File::delete($view_path . $view_name . '.blade.php');
			}

			$template->delete();
		} else {
			return response()->json(false);
		}

		return response()->json(true);
	}
}