<?php
namespace App\Http\Controllers\Admin\Ajax;

use Input,DB;

class GiftCardsController extends AjaxController {

  public function __construct()
  {
      parent::__construct();
  }

  public function postGiftCardsTable()
	{
		$order = Input::get('order', false);
		$start = Input::get('start', 0);
		$length = Input::get('length', 25);

		$fields = [
			'startDate' => false,
			'endDate' => false,
			];
			
		$giftcards=\App\Models\GiftCards::select(DB::raw('gift_cards.*'));
		
		if ($owner = Input::get('owner')){
			if($owner=="-1")
				$giftcards=$giftcards->whereNull('owner_id');
			if(strlen($owner)>3)
			$giftcards=$giftcards->where('owner_id','=',$owner);
		}

		if ($title = Input::get('title')){

			$giftcards=$giftcards->where('title','LIKE','%'.$title.'%');
		}

		$startDate = Input::get( 'startDate', $fields['startDate'] );
    $endDate = Input::get( 'endDate', $fields['endDate'] );


		if( $startDate && $startDate !== '' && $endDate && $endDate !== '' ) {
				$startDate = \App\Models\Date::format( $startDate );
				$endDate = \App\Models\Date::format( $endDate );
				$giftcards=$giftcards->whereRaw("(DATE(created_at) BETWEEN '" . $startDate . "' AND '" . $endDate . "')");
		}

		$start = ( $start < 1 ) ? 0 : $start;
    	$length = ( $length < 1 ) ? 25 : $length;

		if ( $order && !empty( $order ) ) {
      		$_order = array_pop($order);
      		$dir = $_order['dir'];

		    switch ( $_order['column'] ) {
		      	case 0:
		        	$order_by = 'id';
		          break;
				case 1:
				  $order_by = 'owner_id';
			  	break;
                case 2:
                    $order_by = 'title';
                    break;
		        case 3:
		        	$order_by = 'hash';
		          break;
		        case 4:
		        	$order_by = 'amount';
		          break;
                case 5:
                    $order_by = 'amount_left';
                    break;
		        case 6:
		          $order_by = 'created_at';
		          break;
		        default:
		         	$dir = 'asc';
		         	$order_by = 'id';
		        break;
		    }

		 	}

		$giftcards=$giftcards->orderBy($order_by,$dir);
		$giftcards_count = $giftcards->count();
  		$giftcards_total = $giftcards->skip( $start )->take( $length )->count();
  		$giftcards = $giftcards->skip( $start )->take( $length )->get();
		foreach($giftcards as $giftcard){
			if($user = \App\Models\User::where('id', $giftcard->owner_id)->first())
				$giftcard->username=$user->username;
			else
				$giftcard->username='-';
		}
  	$response = ['draw' => Input::get('draw', 1), 'data' => $giftcards, 'recordsFiltered' => $giftcards_count, 'recordsTotal' => $giftcards_total];

    return $this->responseTable( $response );
	}

	public function postDelete()
	{
		$id = Input::get('id', null);

		if( is_null( $giftcard = \App\Models\GiftCards::where('id', $id)->first() ) )
			return response()->json(false);

		$giftcard->forceDelete();

		return response()->json(true);
	}

}
