<?php 
namespace App\Http\Controllers\Admin\Ajax;

use Input;

class NewsController extends AjaxController {

  public function __construct()
  {
      parent::__construct();
  }

  public function postNewsTable()
	{
		$order = Input::get('order', false);
		$start = Input::get('start', 0);
		$length = Input::get('length', 25);

		$start = ( $start < 1 ) ? 0 : $start;
    	$length = ( $length < 1 ) ? 25 : $length;

		if ( $order && !empty( $order ) ) {
      		$_order = array_pop($order);
      		$dir = $_order['dir'];

		    switch ( $_order['column'] ) {
		      	case 0:
		        	$order_by = 'id';
		          break;
		        case 1:
		        	$order_by = 'title';
		          break;
		        case 2:
		        	$order_by = 'views';
		          break;
		        case 3:
		          $order_by = 'created_at';
		          break;
		        default: 
		         	$dir = 'asc';
		         	$order_by = 'id';
		        break;
		    }

		    $news = \App\Models\News::orderBy( $order_by, $dir );
		}
		

		$news_total = $news->count();
  	$news_count = $news->skip( $start )->take( $length )->count();
  	$news = $news->skip( $start )->take( $length )->get();

  	$response = ['draw' => Input::get('draw', 1), 'data' => $news, 'recordsFiltered' => $news_count, 'recordsTotal' => $news_total];

    return $this->responseTable( $response );
	}

	public function postDelete()
	{
		$id = Input::get('id', null);
		
		if( is_null( $article = \App\Models\News::where('id', $id)->first() ) )
			return response()->json(false);

		$article->delete();

		return response()->json(true);
	}

}