<?php 
namespace App\Http\Controllers\Admin\Ajax;

use Input;

class PackagesController extends AjaxController {

  public function __construct()
  {
      parent::__construct();
  }

  public function postPackagesTable()
	{
		$order = Input::get('order', false);
		$start = Input::get('start', 0);
		$length = Input::get('length', 25);

		$start = ( $start < 1 ) ? 0 : $start;
    	$length = ( $length < 1 ) ? 25 : $length;

		if ( $order && !empty( $order ) ) {
      		$_order = array_pop($order);
      		$dir = $_order['dir'];

		    switch ( $_order['column'] ) {
		      	case 0:
		        	$order_by = 'id';
		          break;
		        case 7:
		        	$order_by = 'status';
		          break;
		        default: 
		         	$dir = 'asc';
		         	$order_by = 'id';
		        break;
		    }

		    $packages = \App\Models\Packages::orderBy( $order_by, $dir );
		}
		

		$packages_total = $packages->count();
	  	$packages_count = $packages->skip( $start )->take( $length )->count();
	  	$packages = $packages->skip( $start )->take( $length )->get();

	  	$response = ['draw' => Input::get('draw', 1), 'data' => $packages, 'recordsFiltered' => $packages_count, 'recordsTotal' => $packages_total];

	    return $this->responseTable( $response );
	}

	public function postStatusChange()
	{
		$id = Input::get('id');

		$package = \App\Models\Packages::where('id', $id)->first();

		if( $package->status == 0 ) {
			$package->status = 1;
		} else $package->status = 0;

		$package->save();

		return response()->json(true);
	}

}