<?php 
namespace App\Http\Controllers\Admin\Ajax;

use \App\Models\Loans;
use DB, Config, Input;

class SupportController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postCannedResponse()
    {
    $id = Input::get('id');

    $reply = \App\Models\Admin\SupportResponses::where('id', $id)->lists('content');

    return response()->json($reply);
    }



    public function postSupportCategoriesTable()
    {
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 25);

        $start = ( $start < 1 ) ? 0 : $start;
        $length = ( $length < 1 ) ? 25 : $length;

        if ( $order && !empty( $order ) ) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ( $_order['column'] ) {
                case 0:
                    $order_by = 'id';
                    break;
                case 1:
                    $order_by = 'name';
                    break;
                case 2:
                    $order_by = 'status';
                    break;
                case 3:
                    $order_by = 'created_at';
                    break;
                default:
                    $dir = 'asc';
                    $order_by = 'id';
                    break;
            }

            $categories = \App\Models\SupportCategories::orderBy( $order_by, $dir );
        }

        $categories_total = $categories->count();
        $categories_count = $categories->skip( $start )->take( $length )->count();
        $categories = $categories->skip( $start )->take( $length )->get();

        $response = [
            'draw' => Input::get('draw', 1),
            'data' => $categories,
            'recordsFiltered' => $categories_count,
            'recordsTotal' => $categories_total
        ];

        return $this->responseTable( $response );
    }

    public function postSupportCategoriesStatusChange()
    {
        $id = Input::get('id');

        $category = \App\Models\SupportCategories::where('id', $id)->first();

        if( $category->status == 0 ) {
            $category->status = 1;
        } else $category->status = 0;

        $category->save();

        return response()->json(true);
    }

    public function postSupportCategoriesDelete()
    {
        $id = Input::get('id', null);

        if( is_null( $category = \App\Models\SupportCategories::where('id', $id)->first() ) )
            return response()->json(false);

        $category->name = $category->name . '_deleted';
        $category->save();
        $category->delete();

        return response()->json(true);
    }
}