<?php
namespace App\Http\Controllers\Admin\Ajax;

use Input, File;

class ToolsController extends AjaxController {

  public function __construct()
  {
      parent::__construct();
  }

  public function postReportsTable()
	{
		$order = Input::get('order', false);
		$start = Input::get('start', 0);
		$length = Input::get('length', 25);

		$start = ( $start < 1 ) ? 0 : $start;
    $length = ( $length < 1 ) ? 25 : $length;

		if ( $order && !empty( $order ) ) {
      		$_order = array_pop($order);
      		$dir = $_order['dir'];

		    switch ( $_order['column'] ) {
		      	case 0:
		        	$order_by = 'id';
		          break;
		        case 3:
		        	$order_by = 'date';
		          break;
		        default:
		         	$dir = 'asc';
		         	$order_by = 'id';
		        break;
		    }

		    $reports = \App\Models\Reports::orderBy( $order_by, $dir );
		}

		$reports_total = $reports->count();
  	$reports_count = $reports->skip( $start )->take( $length )->count();
  	$reports = $reports->skip( $start )->take( $length )->get();

  	$response = ['draw' => Input::get('draw', 1), 'data' => $reports, 'recordsFiltered' => $reports_count, 'recordsTotal' => $reports_total];

    return $this->responseTable( $response );
	}

	public function postDeleteReport()
	{
		$id = Input::get('id');

		$report = \App\Models\Reports::where('id', $id)->first();

    $file1 = storage_path() . '/uploads/reports/' . $report->file_1;
    $file2 = storage_path() . '/uploads/reports/' . $report->file_2;

		if( File::exists( $file1 ) )
      File::delete( $file1 );

    if( File::exists( $file2 ) )
      File::delete( $file2 );

		$report->delete();

		return response()->json(true);
	}

}
