<?php namespace App\Http\Controllers\Admin;

use Validator, Input, Session, Redirect;

class ContentManagerController extends AdminController {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		$contents = \App\Models\Admin\AdminContents::orderBy('id', 'asc')->get();
		return view('admin.content-manager.index', ['contents' => $contents])->withTitle('Content Manager');
	}

	public function view($id)
	{
		if( is_null( $content = \App\Models\Admin\AdminContents::where('id', $id)->first() ) )
			return Redirect::route('admin.content-manager')->with('error', 'Wrong content ID!');

		return view('admin.content-manager.view', ['content' => $content])->withTitle('Edit ' . $content->title);
	}

	public function viewPost($id = null)
	{
		if( is_null( $content = \App\Models\Admin\AdminContents::where('id', $id)->first() ) )
			return Redirect::route('admin.content-manager')->with('error', 'Wrong content ID!');

		$data = Input::all();
		$rules = [
			'translate.*' => 'required',
		];

		$validator = Validator::make($data, $rules);

		if ($validator->fails())
			return Redirect::back()->withInput()->withErrors($validator);

		$content->fill(request()->get('translate'));
		if( $content->save() )
			return Redirect::route('admin.content-manager')->with('success', 'The content has been successfully updated.');

		return Redirect::back()->with('error', 'Could not update content. Try again!');
	}
}