<?php namespace App\Http\Controllers\Admin;

use Redirect, DB, Validator, Input, Session;

class GiftCardsController extends AdminController {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		return view('admin.giftcards.index')->withTitle('Gift Cards');
	}

	public function getNew()
	{
		return view('admin.giftcards.new')->withTitle('Gift Cards - New');
	}

	public function postNew()
	{
		$data = Input::all();

		$rules = [
			'amount' => 'required|numeric',
            'user_id' => 'required|numeric',
            'title' => 'required|max:50',
		];

		$validator = Validator::make($data, $rules);

		if ( $validator->fails() )
      		return Redirect::back()->withInput()->withErrors($validator);

		$giftCard = new \App\Models\GiftCards;
    	$giftCard->hash = md5(uniqid(rand(), TRUE));
		$giftCard->amount = $data['amount'];
        $giftCard->amount_left = $data['amount'];
        $giftCard->deleted = 0;
        $giftCard->owner_id = $data['user_id'];
        $giftCard->title = $data['title'];

		if( $giftCard->save() )
			return Redirect::route('admin.giftcards.new')->with('success', 'Gift card has been created.')->with('hash', $giftCard->hash);

		return Redirect::back()->with('error', 'Could not create gift card.');
	}

}
