<?php namespace App\Http\Controllers\Admin;

use DB;

class HistoryController extends AdminController
{
    public function __construct()
    {
        parent::__construct();
    }

    public function getTransactions()
    {
        $processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->get();
        return view('admin.history.transactions', [
            'types' => \App\Models\Transactions::$types,
            'icons' => \App\Models\Transactions::$icons,
            'processors' => $processors
        ])->withTitle('Transactions');
    }

    public function getCashouts()
    {
        $processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->get();
        return view('admin.history.cashouts', [
            'types' => \App\Models\Transactions::$types,
            'icons' => \App\Models\Transactions::$icons,
            'processors' => $processors
        ])->withTitle('Cashouts');
    }

    public function getTokens()
    {
        $tokens = \App\Models\Packages::orderBy('id', 'asc')->get();
        $processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->get();

        return view('admin.history.tokens', ['tokens' => $tokens, 'processors' => $processors])->withTitle('Packages');
    }

    public function getDeposits()
    {
        $deposits = \App\Models\UsersDeposits::orderBy('id', 'asc')->get();
        $currencies = \App\Models\UsersDeposits::select('currency_name')->groupBy('currency_name')->get();
        $sources = \App\Models\UsersDeposits::select('transaction_source_system')->groupBy('transaction_source_system')->get();
        //$processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->get();

        return view('admin.history.deposits', ['sources' => $sources, 'currencies' => $currencies, 'deposits' => $deposits/*, 'processors' => $processors*/])->withTitle('Deposits');
    }
}