<?php 

namespace App\Http\Controllers\Admin;

use Queue, Validator, Input, Session, Redirect;

class MassMailerController extends AdminController {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		$templates = \App\Models\Admin\EmailTemplates::orderBy('title', 'asc')->get();
		return view('admin.massmailer.index', ['templates' => $templates])->withTitle('Mass Mailer');
	}

	public function send()
	{
		$data = Input::all();
		$rules = [
			'to' => 'required|in:0,1,2,3,4,5,6,7',
			'specify-list' => 'required_if:to,7',
			'method' => 'required|array',
			'from' => 'required',
			'from_display' => 'required',
			'content' => 'required',
			'subject' => 'required'
		];

		$validator = Validator::make($data, $rules);

		if ( $validator->fails() ) 
			return Redirect::back()->withInput()->withErrors( $validator );

    $queue_data = Input::except('_token');

    $massmail = new \App\Models\MassMails;
    $massmail->data = json_encode( $queue_data );
    $massmail->save();

    $this->dispatch( new \App\Jobs\SendMassEmails( $queue_data ) );

    return Redirect::route('admin.massmailer')->with('success', 'Mass Email successfully sent.');
	}

}
