<?php namespace App\Http\Controllers\Admin;

use Input;

class ProcessorsController extends AdminController {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		$processors = \App\Models\Processors::orderBy('id', 'asc')->get();
		$hiddenFields = ['in_alternate_pass', 'out_password', 'ipn_security_code'];
		return view('admin.processors.index', ['processors' => $processors, 'hiddenFields' => $hiddenFields])->withTitle('Processors');
	}

	public function postSave()
	{
		$processors = \App\Models\Processors::orderBy('id', 'asc')->get();
		$data = Input::except('_token');
		$defaults = ['fee_fund_status', 'fee_fund', 'fee_cashout_status', 'fee_cashout', 'limit_fund_min', 'limit_fund_max', 'limit_cashout_min', 'limit_cashout_max', 'auto_cashout'];
		$update = [];
		$booleans = [];

		foreach( $data as $key => $d ) {
			$id = explode('-', $key);

			if( !isset( $id[0] ) ) $update[$id[0]] = [];

			switch( $id[1] ) {
				case 'data':

					if( !isset( $update[ $id[0] ]['data'] ) ) $update[ $id[0] ]['data'] = [];

					$update[ $id[0] ]['data'][ $id[2] ] = $d;

				break;
				default:

					$update[ $id[0] ][ $id[1] ] = $d;

				break;
			}
		}

		foreach( $update as $key => $value ) {

			foreach( $defaults as $d ) {
				if( !isset( $value[ $d ] ) ) $value[ $d ] = 0;
			}

			if( isset( $value['data'] ) ) {

				foreach( $processors as $proc ) {
					if( $key == $proc->id ) {
						$value['data'] = array_merge( json_decode( $proc->data, true ), $value['data'] );
						$value['data'] = json_encode( $value['data'] );
					}
				}
			}

			\App\Models\Processors::where('id', $key)->update($value);
		}

		return redirect()->back()->with('success', 'Processors have been successfully saved.');
	}

}
