<?php 
namespace App\Http\Controllers\Admin;

class RequestsController extends AdminController {

	public function __construct()
	{
		parent::__construct();
	}

	public function getPendingDeposits()
	{
		$pending_total = \App\Models\Transactions::where('status', 0)->where('processor_id', '!=', 1)->whereIn('type', [1,2,3,4,5,6])->sum('amount');

		return view('admin.requests.pending-deposits', ['pending_total' => $pending_total])->withTitle('Requests - Pending Deposits');
	}

	public function getPendingCashouts()
	{
		$pending_total = \App\Models\Transactions::where('status', 0)->where('processor_id', '!=', 1)->whereIn('type', [7,8,9,10,11])->sum('amount');

		return view('admin.requests.pending-cashouts', ['pending_total' => $pending_total])->withTitle('Requests - Pending Withdraws');
	}

	public function getPendingPrincipal()
	{
		$pending_total = \App\Models\UsersPlans::where('status', 2)->orderBy('created_at', 'desc')->orderBy('status', 'asc')->sum('balance');

		return view('admin.requests.pending-principal', ['pending_total' => $pending_total])->withTitle('Requests - Principal');
	}

	public function getPendingBanks()
	{
		return view('admin.requests.pending-banks')->withTitle('Requests - Banks');
	}

	public function getPendingGatewayAccounts()
	{
		return view('admin.requests.pending-gatewayAccounts')->withTitle('Requests - Gateway Accounts');
	}

}