<?php namespace App\Http\Controllers\Admin;

use DB, Input, Request;

class SummaryController extends AdminController
{
    public function getAccounting()
    {
        return view('admin.summary.accounting')->withTitle('Accounting');
    }

    /*public function getBalances()
    {
        $data = \App\Models\UsersBalances::select(DB::raw('SUM(COALESCE(`wallet`, 0.00)) as wallet, SUM(COALESCE(`offset_units`, 0.00)) as offset_units, SUM(COALESCE(`resale_units`, 0.00)) as resale_units, SUM(COALESCE(`online_account`, 0.00)) as online_account, SUM(COALESCE(`cv_wallet`, 0.00)) as cv_wallet'))->get();
        return view('admin.summary.balances', ['data' => $data])->withTitle('Balances');
    }*/

    public function getBalances()
    {
        $sum_users_wallet = \App\Models\UsersBalances::select(DB::raw('SUM(COALESCE(`wallet`, 0.00)) as wallet'))->get();
        $sum_users_bids = \App\Models\AuctionUsersPackages::select(DB::raw('SUM(COALESCE(`bids`, 0.00)) as bid'))->get();
        $sum_users_deposit = \App\Models\UsersDeposits::select(DB::raw('SUM(COALESCE(`currency_amount`, 0.00)) as deposit'))->get();
        $sum_users_giftcard = \App\Models\GiftCards::select(DB::raw('SUM(COALESCE(`amount_left`, 0.00)) as giftcard'))->whereRaw('deleted = 0')->get();

        $data = [
            'sum_users_wallet' => $sum_users_wallet,
            'sum_users_bids' => $sum_users_bids,
            'sum_users_deposit' => $sum_users_deposit,
            'sum_users_giftcard' => $sum_users_giftcard
        ];





        $packagesByTypes = [];
        $totalUsers = \App\Models\User::where('newUser', 0)->count();
        $totalPackages = \App\Models\UsersPackages::where('status', 1)->count();
        //$totalBTC = DB::select(DB::raw('select SUM(received_btc) AS total FROM users_btc_addresses'));

        $totalUSD = DB::select(DB::raw('select SUM(received) AS total FROM user_addresses'));

        $dailyPurchases = \App\Models\UsersPackages::select(DB::raw('COUNT(id) AS count, DATE_FORMAT(created_at, "%m-%d") AS date'))->whereRaw('(`created_at` > DATE_SUB(now(), INTERVAL 7 DAY))')->groupBy('date')->orderBy('date')->get();


        $totalUSD = $totalUSD[0]->total;

        $totalPackages = round($totalPackages - ($totalPackages * 26 / 100));

        foreach( \App\Models\UsersPackages::select(DB::raw('packages.name, COUNT(users_packages.id) AS count'))->join('packages', 'packages.id', '=', 'users_packages.package_id')->where('users_packages.status', 1)->groupBy('package_id')->groupBy('packages.name')->get() as $pbt ) {
            $packagesByTypes[] = (object)[
                'percent' => round($pbt->count - ($pbt->count * 26 / 100)) / $totalPackages * 100,
                'count' => round($pbt->count - ($pbt->count * 26 / 100)),
                'name' => $pbt->name
            ];
        }

        foreach ($dailyPurchases as $dp) {
            $dp->count = round($dp->count - ($dp->count * 26 / 100));
        }

        $summary = (object)[
            'activeUsers'   => round($totalUsers - ($totalUsers * 26 / 100)),
            'totalUsers'    => \App\Models\User::count(),
            'totalPurchases' => $totalPackages,

            '$totalUSD' => 0,
            //'totalBTC' => 0,//bcdiv($totalBTC - ($totalBTC * 9.6 / 100), 1, 6),
            'dailyPurchases' => \App\Models\UsersPackages::select(DB::raw('COUNT(id) AS count, DATE_FORMAT(created_at, "%y-%m-%d") AS date'))->where('status', 1)->whereRaw('(`created_at` > DATE_SUB(now(), INTERVAL 7 DAY))')->groupBy('date')->orderBy('date')->get(),
            'packagesByTypes' => $packagesByTypes
        ];

        $userUSDAddresses = DB::select(DB::raw("select uua.user_id, uua.address, uua.amount, uua.received, u.username, uua.created_at from user_addresses as uua join users as u on uua.user_id = u.id where uua.created_at >= '2018-11-12 00:00:00' and received >= amount order by uua.id DESC LIMIT 0,300"));


        $addresses = [];

        foreach( $userUSDAddresses as $uua ) {


            $addresses[ $uua->user_id ] = [
                'username' => $uua->username,
                'created_at' => $uua->created_at,
                'address' => $uua->address,
                'amount' => $uua->amount,
                'received' => $uua->received
            ];
        }

        $addresses = collect($addresses);


        return view('admin.summary.balances', [
            'data' => $data,
            'summary' => $summary,
            'addresses' => $addresses
        ])->withTitle('Balances');
    }

    public function getProcessorBreakdown()
    {
        $fields = [
            'startDate' => false,
            'endDate' => false
        ];

        $startDate = Input::get( 'startDate', $fields['startDate'] );
        $endDate = Input::get( 'endDate', $fields['endDate'] );

        if( $startDate !== '' && $endDate !== '' ) {
            $startDate = \App\Models\Date::format( $startDate );
            $endDate = \App\Models\Date::format( $endDate );
        }

        $processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->pluck('name', 'id');

        $_data = \App\Models\Transactions::select(DB::raw('SUM(COALESCE(`amount`, 0.00)) as amount, type, processor_id, transactions.status'))->groupBy('processor_id', 'transactions.type')->whereRaw("(DATE(created_at) BETWEEN '" . $startDate . "' AND '" . $endDate . "')")->where('transactions.status', 1)->where('processor_id', '!=', 4)->orderBy('processor_id', 'asc')->get();
        $data = [];

        foreach( $_data as $d ) {
            if( !isset($data[ $d->processor_id ]) ) {
                $data[ $d->processor_id ] = [];
                $data[ $d->processor_id ]['name'] = $processors[ $d->processor_id ];
                $data[ $d->processor_id ]['deposit'] = 0.00;
                $data[ $d->processor_id ]['cash'] = 0.00;
            }

            if( $d->type < 7 )
                $data[ $d->processor_id ]['deposit'] = $data[ $d->processor_id ]['deposit'] + $d->amountNumber;
            else
                $data[ $d->processor_id ]['cash'] = $data[ $d->processor_id ]['cash'] + $d->amountNumber;
        }

        return view('admin.summary.processorBreakdown', ['data' => $data, 'processors' => $processors, 'oldInput' => ['startDate' => $startDate, 'endDate' => $endDate]])->withTitle('Processor Breakdown');
    }
}