<?php

namespace App\Http\Controllers\Auth;

use App\Facades\MailManager;
use App\Http\Controllers\Controller;
use Illuminate\Foundation\Auth\SendsPasswordResetEmails;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Str;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Password;
use Hash, DB;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use Carbon;

class ActivationController extends Controller
{

    public function __construct()
    {
        $this->middleware('guest');
    }

    public function getIndex( Request $request, $activationCode = null )
    {
        $activated = false;

        if( !is_null( $user = \App\Models\User::where('activation_code', $activationCode)->first() ) ) {

            $activated = true;

            if( $user->attemptActivation( $activationCode ) ) {
                Auth::login( $user, true );
                return redirect( $this->redirectPath() );
            }
        }

        return view('auth.activation', ['activated' => $activated])->withTitle('Activation');
    }


    public function redirectPath()
    {
        if (method_exists($this, 'redirectTo')) {
            return $this->redirectTo();
        }

        return property_exists($this, 'redirectTo') ? $this->redirectTo : '/desk';
    }

}