<?php

namespace App\Http\Controllers\Clientzone\Ajax;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

use Auth;

class AjaxController extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
	
	protected $results = ['error' => false, 'data' => []];

	public function __construct()
	{
		$this->middleware(function ($request, $next) {

        	if( Auth::check() ) {
        		$this->user = Auth::user();
        	}

        	return $next( $request );
        });
	}

	public function response( $response = false ) {
		if( $response ) $this->results = array_merge($this->results, $response);

		return response()->json( $this->results ); 
	}

	public function responseNew( $error = null, $response = null ) {
        $resp = ['error' => null, 'data' => null];

        if( !is_null( $error ) )
            $resp = array_merge($resp, ['error' => $error]);
        else
            $resp = array_merge($resp, ['data' => $response]);

        return response()->json($resp);
    }

	public function responseTable( $response ) {
		return response()->json( $response ); 
	}
}