<?php 
namespace App\Http\Controllers\Clientzone\Ajax;

use Input, DB, Config, Cart;

class AuctionPurchaseController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postAuctionPurchaseTable()
	{
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 10);

        //$giftcards = \App\Models\GiftCards::select(DB::raw('packages.name as name, gift_cards.*, users.username AS usedByUsername'))->join('packages', 'packages.id', '=', 'gift_cards.package_id')->leftJoin('users', 'users.id', '=', 'gift_cards.used_by')->where('owner_id', $this->user->id)->withTrashed();

        //$giftcards = \App\Models\GiftCards::where('owner_id', $this->user->id)->get();

        $auctionpurchases = \App\Models\AuctionPurchases::select(DB::raw('id, user_id, item_id, price, status, type, created_at'));
        $auctionpurchases = $auctionpurchases->whereRaw("user_id = '" . $this->user->id . "'");

        //$giftcards = \App\Models\GiftCards::where('owner_id', $this->user->id)->get();
        //clock()->info($giftcards);

        //$dir = 'desc';
        //$order_by = 'created_at';

        if ($order && !empty($order)) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ($_order['column']) {
                case 0:
                    $order_by = 'id';
                    break;
                case 1:
                    $order_by = 'item_id';
                    break;
                case 2:
                    $order_by = 'price';
                    break;
                case 3:
                    $order_by = 'status';
                    break;
                case 5:
                    $order_by = 'type';
                    break;
                case 6:
                    $order_by = 'created_at';
                    break;
                default:
                    $dir = 'desc';
                    $order_by = 'created_at';
                    break;
            }
        }

        $auctionpurchases = $auctionpurchases->orderBy($order_by, $dir);

        $auctionpurchases_count = $auctionpurchases->count();
        $auctionpurchases_total = $auctionpurchases->skip( $start )->take( $length )->count();
        $auctionpurchases = $auctionpurchases->skip( $start )->take( $length )->get();

        foreach( $auctionpurchases as $t ) {
            if($t->status == 1){
                $t->status = trans('status.under_process');
            }
            else if($t->status == 2){
                $t->status = trans('status.shipping');
            }
            else if($t->status == 3){
                $t->status = trans('status.delivered');
            }
            else{
                $t->status = trans('status.undetermined');
            }

            $t->price = '$ ' . number_format($t->price, 2);

            $auction_item = \App\Models\AuctionItems::where('id', $t->item_id)->first();
            $t->item_id = $auction_item->title;

            if($t->type == 'Online Wallet'){
                $t->type = trans('status.online_wallet');
            }
            else if ($t->type == 'Gift Card'){
                $t->type = trans('status.gift_card');
            }
            else{
                $t->type = trans('status.unknown');
            }

        }



        $response = [
            'draw' => Input::get('draw', 1), 
            'data' => $auctionpurchases,
            'recordsFiltered' => $auctionpurchases_count,
            'recordsTotal' => $auctionpurchases_total
        ];

        return response()->json($response);
	}

    public function postAuctionPurchaseStatusChange()
    {
        $id = Input::get('id');
        $code = Input::get('code');

        $purchase = \App\Models\AuctionPurchases::where('id', $id)->first();


        /*clock()->info($id);
        clock()->info($code);
        clock()->info($purchase);*/

        $purchase->status = $code;

        $purchase->save();

        return response()->json(true);
    }
}