<?php 
namespace App\Http\Controllers\Clientzone\Ajax;

use Input, DB, Config;

class CertificatesController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postCertificatesTable()
	{
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 10);

		$certificates = \App\Models\Certificates::where('user_id', $this->user->id);

        if ($order && !empty($order)) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ($_order['column']) {
                case 0:
                    $order_by = 'name';
                    break;
                case 1:
                    $order_by = 'units';
                    break;
                default:
                    $dir = 'desc';
                    $order_by = 'created_at';
                    break;
            }

        }

        $certificates = $certificates->orderBy($order_by, $dir);

        $certificates_count = $certificates->count();
        $certificates_total = $certificates->skip( $start )->take( $length )->count();
        $certificates = $certificates->skip( $start )->take( $length )->get();

        $response = ['draw' => Input::get('draw', 1), 'data' => $certificates, 'recordsFiltered' => $certificates_count, 'recordsTotal' => $certificates_total];
        return response()->json($response);
	}

    public function postDonateHistoryTable()
    {
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 10);

        $donates = \App\Models\Transactions::where('user_id', $this->user->id)->where('type', 21);

        if ($order && !empty($order)) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ($_order['column']) {
                case 0:
                    $order_by = 'amount';
                    break;
                case 1:
                    $order_by = 'created_at';
                    break;
                default:
                    $dir = 'desc';
                    $order_by = 'created_at';
                    break;
            }

        }

        $donates = $donates->orderBy($order_by, $dir);

        $donates_count = $donates->count();
        $donates_total = $donates->skip( $start )->take( $length )->count();
        $donates = $donates->skip( $start )->take( $length )->get();

        $response = ['draw' => Input::get('draw', 1), 'data' => $donates, 'recordsFiltered' => $donates_count, 'recordsTotal' => $donates_total];
        return response()->json($response);
    }
}