<?php

namespace App\Http\Controllers\Clientzone\Ajax;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

use Input, DB, Config;

class DepositsController extends AjaxController
{
    public function __construct()
    {
        parent::__construct();
    }

    public function postDepositsTable()
    {
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 10);

        $deposits = \App\Models\UsersDeposits::where('user_id', $this->user->id);

        if ($order && !empty($order)) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ($_order['column']) {
                case 0:
                    $order_by = 'uuid';
                    break;
                /*case 1:
                    $order_by = 'user_id';
                    break;
                case 2:
                    $order_by = 'email';
                    break;*/
                case 1:
                    $order_by = 'usdt_value';
                    break;
                case 2:
                    $order_by = 'coin_rate';
                    break;
                case 3:
                    $order_by = 'currency_name';
                    break;
                case 4:
                    $order_by = 'currency_amount';
                    break;
                case 5:
                    $order_by = 'comment';
                    break;
                case 6:
                    $order_by = 'transaction_source_system';
                    break;
                case 7:
                    $order_by = 'status';
                    break;
                case 8:
                    $order_by = 'created_at';
                    break;
                default:
                    $dir = 'desc';
                    $order_by = 'created_at';
                    break;
            }
        }

        $deposits = $deposits->orderBy($order_by, $dir);

        $deposits_count = $deposits->count();
        $deposits_total = $deposits->skip( $start )->take( $length )->count();
        $deposits = $deposits->skip( $start )->take( $length )->get();

        //$statuses = [1 => 'Active', 'Expired'];

        foreach( $deposits as $t ) {
            $t->usdt_value = number_format($t->usdt_value, 2);
            $t->coin_rate = number_format($t->coin_rate, 2);
            $t->currency_amount = number_format($t->currency_amount, 2);

            if($t->status == 0){
                $t->status = trans('status.completed');
            }

        }

        $response = [
            'draw' => Input::get('draw', 1),
            'data' => $deposits,
            'recordsFiltered' => $deposits_count,
            'recordsTotal' => $deposits_total
        ];

        return response()->json($response);
    }
    /*
    public function postPackagesAddTo() {
        $id = Input::get('id', null);
        $quantity = Input::get('quantity', 1);

        if(is_null( $package = \App\Models\Packages::where('id', $id)->first() ) ) {
            return $this->responseNew('Wrong package id');
        }

        if( $quantity > 10 ) {
            $quantity = 10;
        } elseif( $quantity < 1 ) {
            $quantity = 1;
        }

        $cart = Cart::instance('packages');

        if( $this->user->isNewUser() ) {
            $quantity = 1;
            $cart->destroy();
        } else {
            //$checkCarts = $cart->search(function ( $cartItem, $rowId ) use ($id) {
            //    return $cartItem->id === $id;
            //});
            $cart->destroy();
        }

        //if( $this->user->isNewUser() && isset( $checkCarts) && $checkCarts->count() ) {
        //    $item = $checkCarts->first();
        //    $cart->update($item->rowId, $quantity);
        //} else {
        $cart->add(
            ['id' => $package->id, 'name' => $package->name, 'qty' => $quantity, 'price' => $package->price]
        );
        //}

        return $this->response([ 'data' => [
            'result' => true,
            'packageName' => $package->name,
            'packageQuantity' => $quantity,
            'totalCost' => $cart->total()
        ]]);

    }
    */

}
