<?php 
namespace App\Http\Controllers\Clientzone\Ajax;

use Input, DB, Config, Cart;

class GiftCardsController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postGiftCardsTable()
	{
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 10);

        $giftcards = \App\Models\GiftCards::select(DB::raw('id, title, hash, amount, amount_left, deleted, created_at'));
        $giftcards = $giftcards->whereRaw("owner_id = " . $this->user->id);


        if ($order && !empty($order)) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ($_order['column']) {
                case 0:
                    $order_by = 'id';
                    break;
                case 1:
                    $order_by = 'title';
                    break;
                case 2:
                    $order_by = 'hash';
                    break;
                case 3:
                    $order_by = 'amount';
                    break;
                case 4:
                    $order_by = 'deleted';
                    break;
                case 5:
                    $order_by = 'created_at';
                    break;
                default:
                    $dir = 'desc';
                    $order_by = 'created_at';
                    break;
            }
        }

        $giftcards = $giftcards->orderBy($order_by, $dir);

        $giftcards_count = $giftcards->count();
        $giftcards_total = $giftcards->skip( $start )->take( $length )->count();
        $giftcards = $giftcards->skip( $start )->take( $length )->get();

        foreach( $giftcards as $t ) {
            if($t->deleted == 0){
                $t->deleted = trans('status.available');
            }
            else if($t->deleted == 1){
                $t->deleted = trans('status.discharged');
            }
            else{
                $t->deleted = trans('status.undetermined');
            }

            $t->amount = '$ ' . number_format($t->amount, 2);
            $t->amount_left = '$ ' . number_format($t->amount_left, 2);
        }

        $response = [
            'draw' => Input::get('draw', 1), 
            'data' => $giftcards, 
            'recordsFiltered' => $giftcards_count, 
            'recordsTotal' => $giftcards_total
        ];

        return response()->json($response);
	}

    public function postGiftCardActivate(){
        $uid = Input::get('uid', 0);

        $card = \App\Models\GiftCards::where('hash', $uid)->first();

        if(is_null($card)){
            return $this->responseNew(trans('giftcards.shared.not_found'));
        }
        if($card->deleted != 0){
            return $this->responseNew(trans('giftcards.shared.card_has_been_discharged'));
        }
        if(!is_null($card->owner_id)){
            return $this->responseNew(trans('giftcards.shared.card_belogngs_to_someone'));
        }

        $card->owner_id = $this->user->id;

        if($card->save()){
            return $this->responseNew(null, [
                'result' => true,
                'code' => $uid
            ]);
        }
        else{
            return $this->responseNew(trans('giftcards.shared.cannot_complete_activation'));
        }

        /*$response = [
            'error' => 0,
            'code' => $uid
        ];

        return response()->json($response);*/
    }
}