<?php 
namespace App\Http\Controllers\Clientzone\Ajax;

use Input, DB, Config;

class GreenShillingController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postMiningHistoryTable()
	{
        $order = Input::get('order', false);
        $start = Input::get('start', 0);
        $length = Input::get('length', 10);

		$history = \App\Models\GreenShillingHistory::where('user_id', $this->user->id);

        if ($order && !empty($order)) {
            $_order = array_pop($order);
            $dir = $_order['dir'];

            switch ($_order['column']) {
                case 0:
                    $order_by = 'slots';
                    break;
                case 1:
                    $order_by = 'units';
                    break;
                case 2:
                    $order_by = 'period_from';
                    break;
                case 3:
                    $order_by = 'wallet';
                    break;
                case 4:
                    $order_by = 'created_at';
                    break;
                default:
                    $dir = 'desc';
                    $order_by = 'created_at';
                    break;
            }

        }

        $history = $history->orderBy($order_by, $dir);

        $history_count = $history->count();
        $history_total = $history->skip( $start )->take( $length )->count();
        $history = $history->skip( $start )->take( $length )->get();

        $response = ['draw' => Input::get('draw', 1), 'data' => $history, 'recordsFiltered' => $history_count, 'recordsTotal' => $history_total];
        return response()->json($response);
	}
}