<?php

/* sell-note-accepted
		sell-note-declined
		buy-note-declined
*/

namespace App\Http\Controllers\Clientzone\Ajax;

use Input, Carbon\Carbon, NotificationManager;

class NotificationsController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function postClickNotif()
	{
		$id = Input::get('id', 0);

		if( is_null( $notif = \App\Models\Notifications::where('user_id', $this->user->id )->where('id', $id)->first() ) )
			return $this->response(['error' => trans('messages.wrong_notification_id')]);

		if( $notif->status == 0 ) {
			$notif->status = 1;
			$notif->save();
		}

		return $this->response(['data' => true]);
	}

	public function postGetNotifs()
	{
		//$timestamp = Input::get('tt');

		if( is_null( $notifs = \App\Models\Notifications::check( $this->user->id ) ) )
			return $this->response(['data' => []]);

		//$templates = NotificationManager::getTemplates();



        //clock()->info("Noficitation fetch started..." . count($notifs));

		$results = [];
		$counter = 0;

		foreach( $notifs as $n ) {
			$results[] = \App\Facades\NotificationManager::build( $n );
            //clock()->info("foreach");
		}

		return $this->response( [ 'data' => $results, 'counter' => $counter ] );
	}

	public function postClearNotif()
    {
        \App\Models\Notifications::where('user_id', $this->user->id )->update(['status' => 1]);

        $results = [];
        $counter = 0;
        return $this->response( [ 'data' => $results, 'counter' => $counter ] );
    }

    public function postDelNotif()
    {
        \App\Models\Notifications::where('user_id', $this->user->id )->forceDelete();

        $results = [];
        $counter = 0;
        return $this->response( [ 'data' => $results, 'counter' => $counter ] );
    }
}
