<?php 
namespace App\Http\Controllers\Clientzone\Ajax;

use Input, DB, Config, Cart;

class ShopController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

    public function postShopAddTo() {
        $id = Input::get('id', null);
        $quantity = 1; //Input::get('quantity', 1);

        if(is_null( $product = \App\Models\Products::where('id', $id)->first() ) ) {
            return $this->responseNew('Wrong products id');
        }

        $cart = Cart::instance('shop');

        if( $cart->content()->count() > 0 )
            $cart->destroy();

        $cart->add(
            ['id' => $product->id, 'name' => $product->name, 'qty' => 1, 'price' => $product->price, 'options' => ['description' => $product->description, 'img' => $product->image]]
        );

        return $this->response([ 'data' => [
            'result' => true,
            'items' => ['rowid' => $cart->content()->first()->rowId,'id' => $product->id, 'name' => $product->name, 'qty' => 1, 'price' => $product->price, 'img' => $product->image, 'description' => $product->description],
            'totalCost' => $cart->total()
        ]]);

    }

    public function postShopRemove( ) {
        $cart = Cart::instance('shop');
        $id = Input::get('id', null);

        if( is_null( $item = $cart->get( $id ) ) )
            return $this->response([ 'error' => 'Wrong item ID' ]);

        $cart->remove( $id );
        return $this->response([ 'data' => [
            'result' => true ] 
        ]);
    }
}