<?php
namespace App\Http\Controllers\Clientzone\Ajax;

use App\Facades\NodeGWManager;
use App\Models\UsersKycs;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Log;
use Input, DB, Config, Validator, Carbon\Carbon, NodeGW, Cart;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Event;
use Intervention\Image\Facades\Image;

class UserController extends AjaxController {

	public function __construct()
	{
		parent::__construct();
	}

	public function deleteImages(Request $request)
    {

        $files = $request->input('files', null);
        $type = $request->input('type', null);
        clock()->info($files);

        UsersKycs::where('user_id', $this->user->id)
            ->where('status', null)
            ->where('type', $type)
            ->update(['status' => 0]);


        return response()->json(["result" => 'success']);

    }

    public function setVerificationPending( Request $request ){

        $id = $request->input('id');

        $user = \App\Models\User::where('id', $id)->first();

        $user->kyc_pending = 1;

        $user->save();

        return response()->json(true);
    }

    public function postDocuments( Request $request )
    {

        $section = 'identification';
        if(
        $request->hasFile('files')
        ) {

            $files = $request->file('files');
            $_result = [];

            if(!File::exists(storage_path('app/public/users/'. $section . '/thumbnails/'))) {
                File::makeDirectory(storage_path('app/public/users/'. $section . '/thumbnails/'), 0775, true);
            }

            foreach( $files as $f ) {
                $filename = str_random(40) . '.' . $f->getClientOriginalExtension();
                $thumbnailPath = storage_path('app/public/users/'. $section . '/thumbnails/');

                Image::make($f->getRealPath())->resize(150, null, function($constraint) {
                    $constraint->aspectRatio();
                    $constraint->upsize();
                })->save($thumbnailPath . $filename);

                $path = $f->storeAs('users/' . $section, $filename, 'public');

                $_result[] = [
                    'name' => $filename,
                    'size' => '',
                    'url' => url('storage/users/' . $section . '/' . $filename),
                    'thumbnailUrl' => url('storage/users/' . $section . '/thumbnails/' . $filename)
                ];

                $user_kyc = new UsersKycs();
                $user_kyc->user_id = $this->user->id;
                $user_kyc->type = $section;
                $user_kyc->document_location = $filename;
                $user_kyc->save();
            }

            return response()->json(["files" => $_result]);
        }
    }

    public function postLocation( Request $request )
    {
        $section = 'address';
        if(
        $request->hasFile('files')
        ) {

            $files = $request->file('files');
            $_result = [];

            if(!File::exists(storage_path('app/public/users/'. $section . '/thumbnails/'))) {
                File::makeDirectory(storage_path('app/public/users/'. $section . '/thumbnails/'), 0775, true);
            }

            foreach( $files as $f ) {
                $filename = str_random(40) . '.' . $f->getClientOriginalExtension();
                $thumbnailPath = storage_path('app/public/users/'. $section . '/thumbnails/');

                Image::make($f->getRealPath())->resize(150, null, function($constraint) {
                    $constraint->aspectRatio();
                    $constraint->upsize();
                })->save($thumbnailPath . $filename);

                $path = $f->storeAs('users/' . $section, $filename, 'public');

                $_result[] = [
                    'name' => $filename,
                    'size' => '',
                    'url' => url('storage/users/' . $section . '/' . $filename),
                    'thumbnailUrl' => url('storage/users/' . $section . '/thumbnails/' . $filename)
                ];

                $user_kyc = new UsersKycs();
                $user_kyc->user_id = $this->user->id;
                $user_kyc->type = $section;
                $user_kyc->document_location = $filename;
                $user_kyc->save();
            }

            return response()->json(["files" => $_result]);
        }
    }
}