<?php 

namespace App\Http\Controllers\Clientzone;

use App\Models\AuctionItems;
use Config, DB, Input, Validator, Session, Redirect, Mail, Queue, MailManager, Cart;
use Illuminate\Support\Carbon;

class AuctionPurchaseController extends ClientzoneController {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		//$total_cards = \App\Models\GiftCards::where('owner_id', $this->user->id)->where('deleted', 0)->sum('amount');

        /*$user_wallet = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();
        $user_purchased_count = \App\Models\AuctionPurchases::where('user_id', $this->user->id)->count();
        $user_total_purchase_amount = \App\Models\AuctionPurchases::where('user_id', $this->user->id)->sum('price');

        $userid = $this->user->id;
        $user_won_items_count = \App\Models\AuctionItems::whereHas('lastBidder', function( $query ) use ( $userid ) {
            $query->where('user_id',  $this->user->id);
        })->where('status', 2)->count();

        */
		/*return view('auctionpurchase.index', [
		    'total_wallet' => $user_wallet->wallet,
            'total_won_items' => $user_won_items_count,
            'total_purchase_amount' => $user_total_purchase_amount,
            'total_purchase_count' => $user_purchased_count
        ])->withTitle( trans('auctionpurchase.index.title') );
		*/
	}

    public function getBasketRemove( $id ) {
        $cart = Cart::instance('auctionpurchase');

        if( is_null( $item = $cart->get( $id ) ) )
            return Redirect::back()->with('error', trans('auctionpurchase.shared.wrongID'));

        $cart->remove( $id );
        return Redirect::back();
    }

    public function getProcess()
    {
        $cart = Cart::instance('auctionpurchase');
        if( $cart->content()->count() == 0 ) 
            return redirect()->route('auction-purchase/process');

        $countries = \App\Models\Country::orderBy('id', 'asc')->get();

        $wallet = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();
        $total_cards = \App\Models\GiftCards::where('owner_id', $this->user->id)->where('deleted', 0)->sum('amount_left');

        return view('auctionpurchase.process', ['countries' => $countries, 'cart' => $cart, 'wallet' => $wallet, 'cards' => $total_cards])->withTitle( trans('auctionpurchase.process.title') );
    }

    public function postProgress()
    {
        $data = Input::all();

        $rules = [
            'form_first_name' => 'required',
            //'middle_name' => 'required',
            'form_last_name' => 'required',
            'form_country' => 'required',
            'form_zip' => 'required',
            //'state' => 'required',
            'form_city' => 'required',
            'form_address' => 'required',
            'form_phone' => 'required',
        ];

        $proc_type = $data['process_type'];

        $validator = Validator::make($data, $rules);

        if ($validator->fails())
            return redirect()->back()->withInput()->withErrors($validator);

        $cart = Cart::instance('auctionpurchase');
        if ($cart->content()->count() == 0)
            return redirect()->route('auction-purchase');


        $new_shipping = new \App\Models\Shippings;
        $new_shipping->user_id = $this->user->id;
        $new_shipping->item_id = $cart->content()->first()->id;
        $new_shipping->comment = $data['form_comment'];
        $new_shipping->status = 1;
        $new_shipping->country_id = $data['form_country'];
        $new_shipping->city = $data['form_city'];
        $new_shipping->zip_code = $data['form_zip'];
        $new_shipping->state = $data['form_state'];
        $new_shipping->address = $data['form_address'];
        $new_shipping->phone = $data['form_phone'];
        $new_shipping->first_name = $data['form_first_name'];
        $new_shipping->middle_name = $data['form_middle_name'];
        $new_shipping->last_name = $data['form_last_name'];


        //clock()->info($cart->content()->pluck('id'));

        //return Redirect::back()->with('error', trans('auctionpurchase.shared.wrongPackage'));


        foreach(AuctionItems::whereIn('id', $cart->content()->pluck('id')) as $cart_item){
            if($cart_item->lastBidder()->first()->user_id != $this->user->id) {
                return Redirect::back()->with('error', trans('auctionpurchase.shared.wrongPackage'));
            }
        }


        if($proc_type == 'wallet') {





            //$wallets = [1 => 'wallet'];

            //clock()->info($wallets);
            //clock()->info($data);

            //$walletName = $wallets[$data['wallet']];

            $user_wallet = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();

            if ($user_wallet->wallet < (float)$cart->total(2, '.', ''))
                return Redirect::back()->with('error', trans('auctionpurchase.shared.noMoney'));

            $user_wallet->wallet = $user_wallet->wallet - (float)$cart->total(2, '.', '');
            $user_wallet->save();
            $new_shipping->save();
        }
        else if ($proc_type == 'giftcard'){

            $total_cards = \App\Models\GiftCards::where('owner_id', $this->user->id)->where('deleted', 0)->sum('amount_left');
            if ($total_cards < (float)$cart->total(2, '.', ''))
                return Redirect::back()->with('error', trans('auctionpurchase.shared.noGift'));

            $gift_cards = \App\Models\GiftCards::where('owner_id', $this->user->id)->where('deleted', 0)->orderBy('amount_left', 'asc')->get();

            $price = (float)$cart->total(2, '.', '');
            foreach($gift_cards as $gift) {
                if ((float)$gift->amount_left <= (float)$price && (float)$price > 0) {
                    $gf = \App\Models\GiftCards::where('id', $gift->id)->first();
                    //$gf->amount = 0;
                    $gf->deleted_at = Carbon::now();
                    $gf->deleted = 1;
                    $gf->used_by = $this->user->id;
                    if($gf->amount == $gf->amount_left) {
                        $price = (float)$price - (float)$gf->amount;
                    }
                    else{
                        $price = (float)$price - (float)$gf->amount_left;
                    }
                    $gf->save();
                } else if ((float)$gift->amount > (float)$price && (float)$price > 0) {
                    $gf = \App\Models\GiftCards::where('id', $gift->id)->first();
                    $gf->amount_left = (float)$gf->amount - (float)$price;
                    $price = (float)$price - (float)$gf->amount;
                    $gf->save();
                } else {
                    break;
                }

            }
            $new_shipping->save();
        }
        else{
            return Redirect::back()->with('error', trans('auctionpurchase.shared.wrong-processor'));
        }

        $items = $cart->content();
        $item = $items->first();
        $id = $item->id;
        $qty = $item->qty;
        $price = $item->price;

        for( $i = 0; $i < $qty; $i++ ) {
            $auction_purchase = new \App\Models\AuctionPurchases;
            $auction_purchase->user_id = $this->user->id;
            $auction_purchase->item_id = $id;
            $auction_purchase->status = 1;
            $auction_purchase->price = $price;
            if($proc_type == 'wallet'){
                $auction_purchase->type = "Online Wallet";
            }
            else if($proc_type == 'giftcard'){
                $auction_purchase->type = "Gift Card";
            }
            else{
                $auction_purchase->type = null;
            }

            $act_shipping = \App\Models\Shippings::where('user_id', $this->user->id)->where('item_id', $id)->first();
            $auction_purchase->shipping_id = $act_shipping->id;
            $auction_purchase->save();
        }

        $cart->destroy();

        $purchased_item = \App\Models\AuctionItems::where('id', $id)->first();
        $purchased_item->status = 3;
        $purchased_item->save();

        return redirect()->route('home')->with('success', trans('auctionpurchase.progress.messages.success'));
    }

	public function getPurchase()
	{
		//$total_cards = \App\Models\GiftCards::where('owner_id', $this->user->id)->where('deleted', 0)->sum('amount_left');
		//$ewallets = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();

        $userid = $this->user->id;

        $user_wallet = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();
        $user_purchased_count = \App\Models\AuctionPurchases::where('user_id', $this->user->id)->count();
        $user_total_purchase_amount = \App\Models\AuctionPurchases::where('user_id', $this->user->id)->sum('price');
        $user_won_items_count = \App\Models\AuctionItems::whereHas('lastBidder', function( $query ) use ( $userid ) {
            $query->where('user_id',  $this->user->id);
        })->where('status', 2)->count();




        $user_won_items = \App\Models\AuctionItems::whereHas('lastBidder', function( $query ) use ( $userid ) {
            $query->where('user_id',  $this->user->id);
        })->where('status', 2)->get();

        $cart = Cart::instance('auctionpurchase');



        //return view('auctionpurchase.index', [
        return view('auctionpurchase.purchase', [
            'total_wallet' => $user_wallet->wallet,
            'total_won_items' => $user_won_items_count,
            'total_purchase_amount' => $user_total_purchase_amount,
            'total_purchase_count' => $user_purchased_count,
            'won_items' => $user_won_items,
            'cart' => $cart,
            'enableRefund' => config('auction.enable_refund')
        //])->withTitle( trans('auctionpurchase.index.title') );
        ])->withTitle(trans('auctionpurchase.purchase.title'));

		/*return view('auctionpurchase.purchase', [
		    //'ewallets' => $ewallets->wallet,
            //'total_cards' => $total_cards,
            'won_items' => $user_won_items,
            'cart' => $cart
        ])->withTitle(trans('auctionpurchase.purchase.title'));*/
	}

	public function postPurchase()
	{
		$data = Input::all();
        $cart = \Gloudemans\Shoppingcart\Facades\Cart::instance('auctionpurchase');

        $id = Input::get('item', null);

        //clock()->info($id);

        $quantity = Input::get('quantity', 1);

        $rules = [
            'item'      => 'required',
            'quantity'  => 'required|min:1'
        ];

        $validator = Validator::make( $data, $rules );

        if ( $validator->fails() )
            return Redirect::back()->withErrors( $validator );

        if(is_null( $act_item = \App\Models\AuctionItems::where('id', $id)->first() ) )
            return Redirect::back()->with('error', trans('auctionpurchase.shared.wrongPackage'));

        if( $quantity > 10 ) {
            $quantity = 10;
        } elseif( $quantity < 1 ) {
            $quantity = 1;
        }

        $cart = \Gloudemans\Shoppingcart\Facades\Cart::instance('auctionpurchase');
        $cart->destroy();


        //clock()->info($act_item->lastBidder()->first()->user_id);
        //clock()->info($this->user->id);

        if($act_item->lastBidder()->first()->user_id == $this->user->id) {

            $cart->add(
                ['id' => $act_item->id, 'name' => $act_item->title, 'qty' => $quantity, 'price' => $act_item->current_price,
                    'options' => [
                        'img' => $act_item->images->first()->thumbnailPath
                    ]
                ]
            );

        }
        else{
            return Redirect::back()->with('error', trans('auctionpurchase.shared.wrongPackage'));
        }

        //clock()->info($cart);

        return Redirect::back();
	}

	public function getShippingInfo($id)
    {
        //return $id;

        $order_user = \App\Models\User::where('id', $this->user->id)->first();
        $order_purchase = \App\Models\AuctionPurchases::where('id', $id)->first();
        $order_shipping = \App\Models\Shippings::where('id', $order_purchase->shipping_id)->first();

        clock()->info($order_purchase);
            if($order_purchase->status == 1){
                $order_purchase->status = trans('status.under_process');
            }
            else if($order_purchase->status == 2){
                $order_purchase->status = trans('status.shipping');
            }
            else if($order_purchase->status == 3){
                $order_purchase->status = trans('status.delivered');
            }
            else{
                $order_purchase->status = trans('status.undetermined');
            }

        $order_purchase->price = '$ ' . number_format($order_purchase->price, 2);

            $auction_item = \App\Models\AuctionItems::where('id', $order_purchase->item_id)->first();
        $order_purchase->item_id = $auction_item->title;


        $datas = [
            'user' => $order_user,
            'purchase' => $order_purchase,
            'shipping' => $order_shipping
        ];

        //clock()->info($datas);

        return view('auctionpurchase.view-shipping', $datas)->withTitle( trans('auctionpurchase.index.shipping') );
    }
}
