<?php 

namespace App\Http\Controllers\Clientzone;


use Redirect, Config;

class MailboxController extends ClientzoneController {

	public function __construct()
	{
		parent::__construct();
		$this->mailbox_list_length = Config::get('app.mailbox_list_length');
	}

	public function inbox()
	{
		return view('mailbox.index')->withTitle(trans('mailbox.title'));
	}

	public function delete( $id = null )
	{
		if( is_null( $message = \App\Models\Messages::where('id', $id)->where('user_id', $this->user->id)->first() ) )
			return Redirect::back()->with('error', trans('mailbox.not_found'));

		$message->delete();

		return Redirect::route('borrowerzone.mailbox.inbox')->with('success', trans('mailbox.deleted'));
	}

	public function markUnread( $id = null )
	{
		if( $id == 'all' ) {
			\App\Models\Messages::where('status', 1)->where('user_id', $this->user->id)->update([
				'status' => 0
			]);

		} else {
			if( is_null( $message = \App\Models\Messages::where('id', $id)->where('user_id', $this->user->id)->first() ) )
				return Redirect::back()->with('error', trans('mailbox.not_found'));

			$message->status = 0;
			$message->save();
		}

		return Redirect::route('borrowerzone.mailbox.inbox')->with('success', trans('mailbox.marked.unread'));
	}

	public function markRead( $id = null )
	{
		if( is_null( $message = \App\Models\Messages::where('id', $id)->where('user_id', $this->user->id)->first() ) )
			return Redirect::back()->with('error', trans('mailbox.not_found'));

		$message->status = 1;
		$message->save();

		return Redirect::route('borrowerzone.mailbox.inbox')->with('success', trans('mailbox.marked.read'));
	}

	public function addstar( $id = null )
	{
		if( is_null( $message = \App\Models\Messages::where('id', $id)->where('user_id', $this->user->id)->first() ) )
			return Redirect::back()->with('error', trans('mailbox.not_found'));

		$message->starred = 1;
		$message->save();

		return Redirect::route('borrowerzone.mailbox.inbox')->with('success', trans('mailbox.addstar'));
	}

	public function removestar( $id = null )
	{
		if( is_null( $message = \App\Models\Messages::where('id', $id)->where('user_id', $this->user->id)->first() ) )
			return Redirect::back()->with('error', trans('mailbox.not_found'));

		$message->starred = 0;
		$message->save();

		return Redirect::route('borrowerzone.mailbox.inbox')->with('success', trans('mailbox.removestar'));
	}

}
