<?php 

namespace App\Http\Controllers\Clientzone;


class NewsController extends ClientzoneController {

	public function __construct()
	{
		parent::__construct();
	}

	public function index()
	{
		$news = \App\Models\News::orderBy('id', 'desc')->paginate(15);
		return view('news.index', ['news' => $news])->withTitle( trans('news.index.title') );
	}

	public function view( $title = null )
	{
		if( is_null( $article = \App\Models\News::where('title_url', $title)->first() ) )
			return redirect()->route('news')->with('error', trans('news.view.messages.error'));

		$recentNews = \App\Models\News::where('title_url', $title)->orderBy('views', 'desc')->get();

		$article->views = $article->views + 1;
		$article->save();

		return view('news.view', ['article' => $article, 'recentNews' => $recentNews])->withTitle( trans('news.index.title') . ' - ' . $article->title );
	}

}
