<?php 

namespace App\Http\Controllers\Clientzone;

use Cart, Input;

class ShopController extends ClientzoneController {

	public function __construct()
	{
		parent::__construct();
	}

	public function getIndex()
	{
		$products = \App\Models\Products::orderBy('id', 'asc')->get();
		$cart = Cart::instance('shop');
		return view('shop.index', ['products' => $products, 'cart' => $cart])->withTitle( trans('shop.index.title') );
	}

	public function getBasket()
	{
		$cart = Cart::instance('shop');
		return view('shop.basket', ['cart' => $cart])->withTitle( trans('shop.basket.title') );
	}

	public function getProcess()
	{
		$cart = Cart::instance('shop');

		if( $cart->content()->count() == 0 ) 
			return redirect()->route('shop.index');

		$wallet = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();

		return view('shop.process', ['cart' => $cart, 'wallet' => $wallet])->withTitle( trans('shop.process.title') );
	}

	public function postProgress()
    {
        $data = Input::all();
        $rules = [
            'wallet' => 'required|in:1'
        ];

        $wallets = [1 => 'wallet'];
        $walletName = $wallets[ $data['wallet'] ];

        $cart = Cart::instance('shop');
        if( $cart->content()->count() == 0 ) 
            return redirect()->route('shop.index');

        $user_wallet = \App\Models\UsersBalances::where('users_id', $this->user->id)->first();

        if( $user_wallet->$walletName < (float)$cart->total(2, '.', '') )
            return Redirect::back()->with('error', trans('shop.shared.noMoney'));

        $user_wallet->$walletName = $user_wallet->$walletName - (float)$cart->total(2, '.', '');
        $user_wallet->save();

        $items = $cart->content();
        $item = $items->first();
        $id = $item->id;
        $qty = $item->qty;
        $price = $item->price;

        for( $i = 0; $i < $qty; $i++ ) {
            $order = new \App\Models\ShopOrders;
            $order->user_id = $this->user->id;
            $order->product_id = $id;
            $order->save();
        }

        $cart->destroy();

        return redirect()->route('shop.index')->with('success', trans('shop.shared.successPurchase'));
    }
}
