<?php 

namespace App\Http\Controllers\Clientzone;

use Redirect, DB, Input;

class TransactionsController extends ClientzoneController {

    public $types = [];
    public $icons = [];

	public function __construct()
	{
		parent::__construct();

		$this->types = \App\Models\Transactions::$types;
		$this->icons = \App\Models\Transactions::$icons;
	}

	public function index()
	{
		$processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->get();

		//clock()->info($this->types);
		//clock()->info(\App\Models\Transactions::getTransactionTypes());

		return view('transactions.index', ['types' => \App\Models\Transactions::$types, 'icons' => $this->icons, 'processors' => $processors])->withTitle( trans('transactions.index.title') );
	}

	public function getPoints()
	{
		return view('transactions.points', [])->withTitle( trans('transactions.points.title') );
	}

	public function getCashouts()
	{
		$processors = \App\Models\Processors::where('id', '!=', 4)->orderBy('id', 'asc')->get();

		$types = [];

		foreach( $this->types as $k => $t ) {
			if( in_array($k, [7,8,9,10,11]) ) {
				$types[ $k ] = $t;
				$icons[ $k ] = $this->icons[ $k ];
			}
		}

		return view('transactions.cashouts', ['types' => $types, 'icons' => $icons, 'processors' => $processors])->withTitle( trans('transactions.cashout.title') );
	}

	public function getAccountSummary()
	{
		return view('transactions.accountSummary')->withTitle( trans('transactions.accountSummary.title') );
	}

	public function getActivationHistory()
	{
		return view('transactions.activationHistory')->withTitle( trans('transactions.activationHistory.title') );
	}
	
}
