<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Igoshev\Captcha\Facades\Captcha;

use Auth, Hash, Config;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;

    public $user;
    public $notificationsUnreadCount;
    public $mailboxUnread;
    public $bodyClass = 'login';

    public function __construct()
    {   
        view()->share('s3StorageUrl', Config::get('app.s3StorageUrl'));

        $this->middleware(function ($request, $next) {

        	if( Auth::check() ) {
        		$this->user = Auth::user();
        		view()->share('user', $this->user);

    			$this->notificationsUnreadCount = \App\Models\Notifications::where('status', 0)->where('user_id', $this->user->id)->count();
    			$this->mailboxUnread = \App\Models\Messages::user($this->user->id)->orderBy('id', 'desc');

    			view()->share('user', $this->user);
    			view()->share('notificationsUnreadCount', $this->notificationsUnreadCount);
    			view()->share('mailboxUnread', $this->mailboxUnread->get());
    			view()->share('mailboxUnreadCount', $this->mailboxUnread->unread()->count());
        	}

            view()->share('bodyClass', $this->bodyClass);

            return $next( $request );
        });
    }
}
