<?php

namespace App\Http\Middleware;

use Closure;
use App;
use Config;
use Session;

class Locale
{
    public function handle($request, Closure $next)
    {
        $raw_locale = Session::get('locale', App::getLocale());

        if ( in_array($raw_locale, array_keys( Config::get('app.languages') ) ) ) {
            $locale = $raw_locale;
        } else $locale = Config::get('app.fallback_locale');

        App::setLocale( $locale );

        return $next( $request );
    }
}