<?php

namespace App\Http\Middleware;

use Illuminate\Foundation\Http\Middleware\VerifyCsrfToken as BaseVerifier;

use Closure;
use Illuminate\Session\TokenMismatchException;

class VerifyCsrfToken extends BaseVerifier
{
    /**
     * The URIs that should be excluded from CSRF verification.
     *
     * @var array
     */
    protected $except = [
        'api/*'
        //
    ];

    public function handle($request, Closure $next)
    {
    	try {
    		return parent::handle( $request, $next );
    	} catch( TokenMismatchException $e ) {

    		return redirect()->back()->with('error', 'Your session has expired.  <br> Please send the form again.')->withInput();
    	}
    }
}
