<?php namespace App\Libraries;

use Config, DB;

class ApcManager {

	private static $apc_keys = [
		'configs' => 'site.configs'
	];

	public static function readConfig()
	{
		$_key = self::$apc_keys['configs'];

		if( apcu_exists( $_key ) ) {
			$fetch = apcu_fetch( $_key );
		} else {
			$fetch = self::storeConfig();
			//$fetch = apc_fetch( $_key );
		}

		foreach( $fetch as $key => $item ) {
			Config::set( $key, $item );
		}
	}

	public static function storeConfig( )
	{
		$_key = self::$apc_keys['configs'];
		$items = [];

		$list = DB::table('configs')->select('value', 'key', 'group')->get();

		foreach ( $list as $config ) {
			if( $config->value == 'true' || $config->value == '1' )
				$config->value = true;
			elseif( $config->value == 'false' || $config->value == '0' )
				$config->value = false;
			elseif( !is_null( $json_value = json_decode( $config->value, true ) ) ) {
				$config->value = $json_value;
			}

      $items[ $config->group . '.' . $config->key ] = $config->value;
    }

    apcu_store( $_key, $items );

    return $items;

	}

}
