<?php
/**
 * Created by PhpStorm.
 * User: noge
 * Date: 2019-06-07
 * Time: 11:41
 */

namespace App\Libraries;


use App\Jobs\RequestCoin;
use App\Models\User;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Mail;

class DirectCommission
{
    /*protected $commissionPercentage = [
        // LEVEL => PERCENT
        1 => 20,
        4 => 5,
        19 => 1
    ];*/

    protected $stepLimit = 9;

    public $user;

    public function __construct(User $user)
    {
        $this->user = $user;
    }

    public function send(){
        $user = $this->user;
        $userPackage = $user->getActivePackage();

        if(!$userPackage){
            Log::debug('$userPackage - ' . $userPackage);
            return false;
        }

        $package = $userPackage->package;

        for($generation = 1; $generation <= $this->stepLimit; $generation++){

            if(!$user->genealogy){

                Log::debug('$user->genealogy - ' . $user->genealogy);
                break;
            }

            //$parent = $user->genealogy->parent;
            $parent = $user->getGenealogyParentUser();

            if(!$parent){
                Log::debug('$parent - ' . $parent);
                break;
            }

            $user = $parent->user;

            if(!$user->getActivePackage()){
                Log::debug('$user->getActivePackage() - ' . $user->getActivePackage());
                continue;
            }

            $percent = $this->getPercent($generation);

            if(!$percent){

                Log::debug('$percent - ' . $percent);
                break;
            }

            $bonus = $package->price_real * $percent / 100;

            if(!$bonus){

                Log::debug('$bonus - ' . $bonus);
                break;
            }

            $transactionCommission            = new \App\Models\Transactions;
            $transactionCommission->user_id   = $user->id;
            $transactionCommission->type      = 3;
            $transactionCommission->processor_id = 5;
            $transactionCommission->amount    = $bonus;
            $transactionCommission->translateOrNew('en')->note      = 'Earned Direct Commission' . ' $' . $bonus . ' from ' . $this->user->username . ' on package ' . $package->name . ' purchase';

            $transactionCommission->translateOrNew('cn')->note      = '获得直推奖金' . ' $' . $bonus . ' 从 ' . $this->user->username . ' 套餐 ' . $package->name . ' 购买';


            $transactionCommission->status    = 1;
            $transactionCommission->save();

            $remoteTransaction = new \App\Models\RemoteTransactions;
            $remoteTransaction->status = 0;
            $remoteTransaction->transaction_id = $transactionCommission->id;
            $remoteTransaction->user_id = $user->id;
            $remoteTransaction->amount = $bonus;
            $remoteTransaction->coin_rate = null;
            //$remoteTransaction->coin_type = $this->user->genealogy->parent->user->getPayoutOption("dc_coin");
            $remoteTransaction->coin_type = "colibri-cpc";
            $remoteTransaction->currency_type = "usdt";
            $remoteTransaction->note = $transactionCommission->translate($user->getUserLanguage())->note;
            $remoteTransaction->save();


            /*try{*/
               dispatch(new RequestCoin($remoteTransaction));

                \App\Facades\MailManager::send('transactions.new-commission', trans('transactions.commissions.new_direct_commission', [], $parent->user->getUserLanguage()),
                    [
                        'id' => $transactionCommission->id,
                        'amount' => $transactionCommission->amount,
                        'note' => $transactionCommission->translate($parent->user->getUserLanguage())->note
                    ], $parent->user);

            /*}catch (\Exception $exception){
                Log::error($exception->getTraceAsString());
                Log::debug('FAILED TO SET DC - ' . $user->id);
            }*/
        }

    }

    public function getPercent($generation){

        foreach(config('mlm.commission_percent_levels') as $key => $value){
            if($generation <= $key){
                return $value;
            }
        }

        return 0;
    }
}