<?php namespace App\Libraries;

use Config, Mail, Carbon\Carbon, DB;

use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;

class NodeGWManager {

	protected $config = [];

	public function __construct()
	{
		$this->init();
	}

	public function init() {
		$this->config['url'] = Config::get('app.nodeUrl') . ':' . Config::get('app.nodePort');
	}

	public function send( $route, $data, $method = 'post' ) {		
		$func = strtolower($method) . 'Request';
		return $this->$func( $route, $data  );
	}

	private function getRequest( $route, $data ) {
		return $this->sendRequest( $route, $data, 'GET' );
	}

	private function postRequest( $route, $data ) {
		return $this->sendRequest( $route, $data );
	}

	private function sendRequest( $route, array $data = [], $method = 'POST' ) {
		$client = new Client;

		switch ($method) {
			case 'GET':
				$data = $data;
			break;
			case 'POST':
				$data = [
					'form_params' => $data
				];
			break;
		}


	    	$result = $client->request($method, $this->config['url'] . '/' . $route, $data);


	    return $result;
	}

}