<?php
/**
 * Created by PhpStorm.
 * User: noge
 * Date: 2019-06-07
 * Time: 12:54
 */

namespace App\Libraries;


use App\Jobs\RequestCoin;
use App\Models\User;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Log;

class ProfitShare
{
    public $user;

    public function __construct(User $user)
    {
        $this->user = $user;
    }

    public function send(){
        $profitShare = config('peak.profitShare');
        $userPackage = $this->user->getActivePackage();

        if(!$userPackage){
            return false;
        }

        $package = $userPackage->package()->first();

        foreach($profitShare as $key => $value){
            $bonus = $package->price_real * $value['percent'] / 100;
            //Log::error($package);
            $user = User::where('email', $value['account'])->first();

            if(!$user){
                $user = new User([
                    'first_name' => "Profit Share",
                    'username' => "profitShareAccount". ucfirst($key),
                    'last_name' => $key,
                    'email' => $value['account'],
                    'password' => 'Almafa12345678910',
                    'secondary_password' => 'Almafa12345678910'
                ]);


                $user->sponsor_code = 0;
                $user->save();

                $user->assignRole('user');

                $user_profile = new \App\Models\UserProfile;
                $user_profile->id           = $user->id;
                $user_profile->avatar       = NULL;
                $user_profile->phone            = "19831983";
                $user_profile->save();

            }

            $transactionCommission            = new \App\Models\Transactions;
            $transactionCommission->user_id   = $user->id;
            $transactionCommission->type      = $value['type'];
            $transactionCommission->amount    = $bonus;
            $transactionCommission->translateOrNew('en')->note = 'Profit share '. $key .' $' . $bonus . ' from ' . $this->user->username . ' on package ' . $package->name . ' purchase';
            $transactionCommission->translateOrNew('cn')->note = '分享利益 '. $key .' $' . $bonus . ' 从 ' . $this->user->username . ' 套餐 ' . $package->name . ' 购买';
            $transactionCommission->status    = 1;
            $transactionCommission->save();

            $remoteTransaction = new \App\Models\RemoteTransactions;
            $remoteTransaction->status = 0;
            $remoteTransaction->transaction_id = $transactionCommission->id;
            $remoteTransaction->user_id = $user->id;
            $remoteTransaction->amount = $bonus;
            $remoteTransaction->coin_rate = null;
            //$remoteTransaction->coin_type = $this->user->genealogy->parent->user->getPayoutOption("dc_coin");
            $remoteTransaction->coin_type = "colibri-cpc";
            $remoteTransaction->currency_type = "usdt";
            $remoteTransaction->note = $transactionCommission->translateOrNew($user->getUserLanguage())->note;
            $remoteTransaction->save();


            try{
                 dispatch(new RequestCoin($remoteTransaction));
            }catch (\Exception $exception){
                Log::debug('SEND PROFIT SHARE - ' . $user->id);
            }

            Log::debug('SEND PROFIT SHARE: '. $key .' - ' . $this->user->id);
        }
    }
}