<?php
/**
 * Created by PhpStorm.
 * User: noge
 * Date: 2019-01-29
 * Time: 15:23
 */

namespace App\Libraries;


use GuzzleHttp\Client;

class WCIApi
{
    private $key;
    private $url;
    private static $markets = [];

    public function __construct() {
        $this->url = config('wci.api.url');
        $this->key = config('wci.api.key');
    }

    public function getLastCpcUsd(){
        $markets = $this->getMarkets("CPC/USD");
        $price = null;

        foreach($markets as $market){
            if($market["Name"] == "Capricoin"){
                $price = $market["Price"];
            }
        }

        return $price;
    }

    public function getLastBtcUsd(){
        $markets = $this->getMarkets("BTC/USD");
        $price = null;

        foreach($markets as $market){
            if($market["Name"] == "Bitcoin"){
                $price = $market["Price"];
            }
        }

        return $price;
    }

    public function getLastBtcCny(){
        $markets = $this->getMarkets("BTC/CNY");
        $price = null;

        foreach($markets as $market){

            if($market["Name"] == "Bitcoin"){
                $price = $market["Price"];
            }
        }

        return $price;
    }

    private function getMarkets($market){
        $pair = explode("/", $market);
        $fiat = $pair[1];

        $data = [
            "fiat" => $fiat
        ];

        if(!isset(self::$markets[$fiat])){
            self::$markets[$fiat] = $this->sendRequest("v2getmarkets", $data, "GET");
        }

        $marketsArray = [];

        try{
            foreach(head(array_get(self::$markets[$fiat], 'Markets')) as $marketArray){

                if($marketArray["Label"] == $market){
                    $marketsArray[] = $marketArray;
                }
            }

        } catch (\Exception $e){
            dump($e);
        }

        return $marketsArray;
    }

    private function sendRequest( $name, $data , $method = "POST") {
        try {

            $client  = new Client([
                //'curl' => [CURLOPT_SSL_VERIFYPEER => false]
            ]);

            $settings = [
                'connect_timeout' => 60,
                'form_params' => array_merge(
                    ["key" => $this->key],
                    $data
                )
            ];


            $request  = $client->request($method, $this->url . '/' . $name, $settings);

            $resultJson = json_decode( $request->getBody()->getContents(), true );

            return $resultJson;

        } catch( \Exception $e ) {
            dump($e);
            return null;
        }
    }
}