<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;
use App\Models\User;
use App;

class AuthResetPassword extends Mailable
{
    use Queueable, SerializesModels;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct( User $user, $token )
    {
        $this->user = $user;
        $this->token = $token;
    }

    /**
     * Build the message.
     
     *
     * @return $this
     */
    public function build( )
    {
        return $this->subject(trans('mail.reset_password'))->view('emails.auth.password')->with([
            'title' => 'Forgot Password',
            'user' => $this->user,
            'token' => $this->token
        ]);
    }
}
