<?php namespace App\Models;

use Str;

class ActivationHistory extends \Illuminate\Database\Eloquent\Model {

  	protected $table = 'activation_history';

  	public $types = [
  		1 => 'No activities this week',
  		2 => 'Sponsor a new member',
  		3 => 'Create a certificate by retailing (:val)',
  		4 => 'Create a Certificate by retiring (:val)',
  		4 => 'Donate tree (:val)',
  		5 => 'Generate 80 cv or more (:val)',
  		6 => 'Purchase or Sell Product'
  	];

  	public function user() {
  		return $this->belongsTo('\App\Models\User', 'user_id', 'id');
  	}

  	public function getTypeNameAttribute( $val ) {
  		return Str::replaceFirst( ':val', $this->amount , $this->types[ $this->type ] );
  	}

  	public function getDates()
	{
	    return ['created_at','updated_at'];
	}
}