<?php
namespace App\Models;

use Illuminate\Database\Eloquent\SoftDeletes;

class AuctionBids extends \Illuminate\Database\Eloquent\Model {

  use SoftDeletes;

  protected $table = 'auction_bids';
  protected $dates = ['created_at', 'updated_at', 'deleted_at'];

  public static function getLastBidId($item_id){
      $result = AuctionBids::where('item_id', $item_id)->orderBy('id', 'desc');
      if($result->count() > 0){
          return $result->first()->id;
      }
      else{
          return null;
      }
  }

  public function item() {
  	return $this->belongsTo('\App\Models\AuctionItems', 'item_id', 'id');
  }

  public function user() {
  	return $this->belongsTo('\App\Models\User', 'user_id', 'id');
  }
}
