<?php
namespace App\Models;

use Illuminate\Database\Eloquent\SoftDeletes;

class AuctionCategories extends \Illuminate\Database\Eloquent\Model {

    use \Astrotomic\Translatable\Translatable;

  use SoftDeletes;

  public $translatedAttributes = ['title'];

  protected $table = 'auction_categories';
  protected $dates = ['created_at', 'updated_at', 'deleted_at'];

  public function items() {
  	return $this->hasMany('\App\Models\AuctionItems', 'id', 'category_id');
  }

  public function getThumbnailPathAttribute( ) {
		return asset('storage/auction/categories/' . $this->thumbnail);
	}
}
