<?php namespace App\Models;

use Illuminate\Database\Eloquent\SoftDeletes;

class Messages extends \Illuminate\Database\Eloquent\Model {

  use SoftDeletes;

  protected $table = 'messages';
  protected $dates = ['created_at', 'updated_at', 'deleted_at'];




  public function scopeUnread( $query )
  {
  	return $query->whereStatus(0);
  }

  public function scopeStarred( $query )
  {
  	return $query->whereStarred(1);
  }

  public function scopeUser($query, $user_id)
  {
    return $query->where('user_id', $user_id);
  }

  public function getDates()
  {
      return ['created_at', 'updated_at', 'deleted_at'];
  }
}