<?php

namespace App\Models;

use DB;

class Notifications extends \Illuminate\Database\Eloquent\Model {

  protected $table = 'notifications';
  protected static $child_tables = ['messages'];

  public static function deleteBy($contentID, $type)
  {
  	if( is_array( $contentID ) )
  		DB::table('notifications')->whereIn('linked_content_id', $contentID)->where('type', $type)->delete();
  	else
  		DB::table('notifications')->where('linked_content_id', $contentID)->where('type', $type)->delete();
  }

  public function getDates()
	{
	  return ['created_at','updated_at'];
	}

	public static function check( $user_id )
	{
	    /*
		return DB::select( DB::raw('
			SELECT
				n.*, typestable.*, u.username, IF(n.linked_user_id = NULL, "", CONCAT_WS(" ", u.first_name, u.last_name) ) as fullname
			FROM
				(
					SELECT id as ID, "messages" as l_type, c.content FROM messages as c
					UNION ALL
					SELECT id as ID, "support-new-reply" as l_type, c.content FROM support_tickets as c
					UNION ALL
					SELECT id as ID, "support-reopen" as l_type, c.content FROM support_tickets as c
					UNION ALL
					SELECT id as ID, "support-closed" as l_type, c.content FROM support_tickets as c
          UNION ALL
          SELECT id as ID, "wallet.transfer" as l_type, NULL as content FROM transactions as c
          UNION ALL
          SELECT id as ID, "wallet.cashout" as l_type, NULL as content FROM transactions as c
          UNION ALL
          SELECT id as ID, "token.interest" as l_type, NULL as content FROM transactions as c
          UNION ALL
          SELECT id as ID, "mlm.referral-commission" as l_type, NULL as content FROM transactions as c
          UNION ALL
          SELECT id as ID, "mlm.binary-commission" as l_type, NULL as content FROM transactions as c

				) as typestable
			LEFT JOIN
				notifications as n on typestable.ID = n.linked_content_id and typestable.l_type = n.type
			LEFT JOIN users as u ON u.id = n.linked_user_id
			WHERE
				n.user_id = ' . $user_id . '
			ORDER BY
				n.id DESC
			LIMIT
				0,10'
		) );
        */

        return DB::select( DB::raw('
        				SELECT
				n.*, typestable.*, u.username, IF(n.linked_user_id = NULL, "", CONCAT_WS(" ", u.first_name, u.last_name) ) as fullname
			FROM
				(
                SELECT id as ID, "messages" as l_type, c.content FROM messages as c
                UNION ALL
                SELECT id as ID, "support-new-reply" as l_type, c.content FROM support_tickets as c
                UNION ALL
                SELECT id as ID, "support-reopen" as l_type, c.content FROM support_tickets as c
                UNION ALL
                SELECT id as ID, "support-closed" as l_type, c.content FROM support_tickets as c
          		UNION ALL
          		SELECT auction_items_id as ID, "auction-overbid" as l_type, c.title AS content FROM auction_items_translations AS c WHERE locale = "'. app()->getLocale() .'"
          		UNION ALL
          		SELECT auction_items_id as ID, "auction-wonitem" as l_type, c.title AS content FROM auction_items_translations AS c WHERE locale = "'. app()->getLocale() .'"
          		UNION ALL
          		SELECT id as ID, "user-deposit" as l_type, c.currency_amount AS content FROM users_deposits AS c 
          		UNION ALL
                SELECT auction_packages_id as ID, "user-auction-package-purchase" as l_type, c.description AS content FROM auction_packages_translations AS c WHERE locale = "'. app()->getLocale() .'"
                UNION ALL
                SELECT auction_packages_id as ID, "user-auction-package-runout" as l_type, c.description AS content FROM auction_packages_translations AS c WHERE locale = "'. app()->getLocale() .'"
                UNION ALL
                SELECT id as ID, "user-verified" as l_type, c.username AS content FROM users AS c

				) as typestable
			LEFT JOIN
				notifications as n on typestable.ID = n.linked_content_id and typestable.l_type = n.type
			LEFT JOIN users as u ON u.id = n.linked_user_id
			WHERE
				n.user_id = ' . $user_id . '
			ORDER BY
				n.id DESC
			LIMIT
				0,10
			'
        ) );
	}
}
