<?php namespace App\Models;

use Illuminate\Support\Facades\Auth;

class Packages extends \Illuminate\Database\Eloquent\Model {

    protected $table = 'packages';
    protected $dates = ['created_at', 'updated_at'];
    public $timestamps = true;

    public function usersTokens()
    {
        return $this->belongsTo('App\Models\UsersPackages', 'package_id');
    }

    public function userCanPurchase(User $user = null){

        if(is_null($user)){
            $user = Auth::user();
        }


        $dependencies = $this->getDependencies();
        $activePackage = null;

        if($user){
            $activePackage = $user->getActivePackage();
        }

        if(is_null($dependencies) && $activePackage){
            return false;
        }

        if(!$activePackage && $dependencies){
            return false;
        }


        if($activePackage && $dependencies  && !in_array($activePackage->package_id, $dependencies)){
            return false;
        }

        return true;
    }

    public function getDependencies(){
        $dependencies = null;

        if(!is_null($this->dependencies)){
            $dependencies = @json_decode($this->dependencies, true);
        }

        return $dependencies;
    }

    public function showableForUser(){
        if($this->id == 2){
            return false;
        }

        if($this->getDependencies()){
            return false;
        }

        return true;
    }
}