<?php namespace App\Models;

class Processors extends \Illuminate\Database\Eloquent\Model {

  protected $table = 'processors';
  public $timestamps = false;

  public function balances()
	{
		return $this->belongsTo('App\Models\UsersBalances', 'processor_id', 'id');
	}

	public function processors()
	{
		return $this->hasMany('\App\Models\UsersProcessors', 'id', 'processor_id');
	}

	public function feeAmount( $process, $amount ) 
	{
    //$key = $process . '_fee';
    $key = 'fee_' . $process;
    $status = $key . '_status';

		if( $this->$status == 1 && $this->$key > 0 )
			return ( $this->$key / 100 ) * $amount;
		else
			return number_format(0, 2);
	}

	public function netAmount( $process, $amount ) 
	{
		return $amount - $this->feeAmount( $process, $amount );
	}

	public function getDates()
	{
	  return [];
	}
}