<?php 
namespace App\Models;

use Illuminate\Database\Eloquent\SoftDeletes;

class Support extends \Illuminate\Database\Eloquent\Model {

  use SoftDeletes;

  protected $table = 'support_tickets';
  protected $dates = ['created_at', 'updated_at', 'deleted_at'];
  public $priorities = [1 => 'LOW', 'MEDIUM', 'HIGH'];

  public function replies()
  {
    return $this->hasMany('App\Models\SupportReplies', 'ticket_id');
  }

  public function scopeActive($query) {
  	return $query->whereStatus(1);
  }

  public function scopeOpen($query) {
  	return $query->whereStatus(0);
  }

  public function scopeClosed($query) {
    return $query->whereStatus(2);
  }

  public function scopeAssigned($query, $user_id) {
    return $query->where('assigned_to', $user_id);
  }

  public function category()
  {
    return $this->hasOne('\App\Models\SupportCategories', 'id', 'category_id');
  }

  public function user()
  {
    return $this->hasOne('\App\Models\User', 'id', 'user_id');
  }

  public function getDates()
	{
	 return ['created_at', 'updated_at', 'deleted_at'];
	}

  public function priorityName()
  {
    if( isset( $this->priority ) ) $prio = $this->priorities[ $this->priority ];
    else $prio = $this->priorities[1];

    return $prio;
  }
}