<?php
namespace App\Models;

use \Kalnoy\Nestedset\NodeTrait;

class TreeGenealogyNested extends \Illuminate\Database\Eloquent\Model
{
	use NodeTrait;

    protected $table = 'tree_genealogy_nested';
    public $timestamps = false;

    public function user() {
        return $this->belongsTo('\App\Models\User', 'id', 'id');
    }

    public function parent() {
        return $this->belongsTo('\App\Models\TreeGenealogyNested', 'parent_id', 'id');
    }

    public function directsWithBP() {
        $directs = $this->children;
        $counter = 0;

        if( !is_null( $directs ) ) {
            foreach( $directs as $d ) {
                if( !$d->user->hasRole('user-migrated') )
                    $counter++;
            }
        }

        return $counter;
    }

    public static function addToTree( $parentId, $userId ) {
        if( is_null( $parent = \App\Models\TreeGenealogyNested::where('id', $parentId)->first() ) )
            return false;

        if( !is_null( $node = \App\Models\TreeGenealogyNested::where('id', $userId)->first() ) )
            return true;

        $node = new \App\Models\TreeGenealogyNested;
        $node->id = $userId;
        $node->parent_id = $parent->id;
        return $node->save();
    }
}