<?php namespace App\Models;

use chillerlan\QRCode\QROptions;
use Illuminate\Support\Facades\File;

class UserProfile extends \Illuminate\Database\Eloquent\Model {

  protected $table = 'users_profiles';
  protected $dates = ['birth_date'];
  public $timestamps = false;

  public function User()
	{
	    return $this->belongsTo('App\Models\User', 'id');
	}

	

	public function country()
	{		
		return $this->hasOne('App\Models\Country', 'id', 'country_id');
	}

    public function getQRCodeAttribute() {
        return storagePathS3('storage/usersdata/qrcodes/' . $this->id  . '.png');
    }

    public function getQRCodePathAttribute() {
        return 'storage/usersdata/qrcodes/' . $this->id  . '.png';
    }

    public function generateQRCode()
    {
        $qrcodePath = storage_path('app/public/usersdata/qrcodes/');
        $qrcodeFile = $qrcodePath . $this->id . '.png';


        if (!File::exists($qrcodePath)) {
            File::makeDirectory($qrcodePath, 0775, true, true);
        }

        if(File::exists($qrcodeFile)) {
            return null;
        }

        $code_options = new QROptions([
            'outputType' => \chillerlan\QRCode\QRCode::OUTPUT_IMAGE_PNG,
            'eccLevel'   => \chillerlan\QRCode\QRCode::ECC_H,
            'scale' => 5
        ]);

        $code = new \chillerlan\QRCode\QRCode($code_options);

        $code->render(
            str_replace('http://', '', route('auth.register', $this->user->username)), $qrcodeFile);
    }
}