<?php namespace App\Models;

use DB;

class UsersPackages extends \Illuminate\Database\Eloquent\Model
{
	protected $table = 'users_packages';

	public function user()
	{
		return $this->belongsTo('\App\Models\User', 'user_id', 'id');
	}

	public function processor()
	{
		return $this->hasOne('\App\Models\Processors', 'id', 'processor_id');
	}

	public function packages()
	{
		return $this->belongsTo('\App\Models\Packages', 'package_id', 'id');
	}

    public function package()
    {
        return $this->hasOne('\App\Models\Packages', 'id', 'package_id');
    }

	public function sponsor()
	{
		return $this->belongsTo('\App\Models\Sponsor', 'user_id', 'user_id');
	}

	public static function investments($userid)
	{
		return self::where('status', '1')
			->where('user_id', $userid)
			->select(DB::raw('SUM(invested_amount) AS invested_amount, MAX(package_id) AS package_id'))
			->groupBy('user_id')
			->first();
	}

	public static function investmentsByDate($userid, $created)
	{
		return self::where('status', '1')
			->where('user_id', $userid)
			->select(DB::raw('SUM(invested_amount) AS invested_amount, MAX(package_id) AS package_id'))
			->where('created_at', '<=', $created)
			->groupBy('user_id')
			->first();
	}
}