<?php namespace App\Models;

class UsersProcessors extends \Illuminate\Database\Eloquent\Model {

  protected $table = 'users_processors';

  public function user()
  {
  	return $this->belongsTo('\App\Models\User', 'user_id', 'id');
  }

  public function scopeOnlyUser($query, $user_id)
  {
  	return $query->where('user_id', $user_id);
  }

  public function processor()
	{
	  return $this->hasOne('App\Models\Processors', 'id', 'processor_id');
	}

  public function bankDetails()
  {
    return $this->hasOne('App\Models\UsersBankDetails', 'id', 'bank_details_id');
  }
}