<?php 
namespace App\Providers;


use Illuminate\Support\ServiceProvider;

class LibrariesServiceProvider extends ServiceProvider
{
    protected $defer = false;

    public function boot()
    {
       
    }

    public function register()
    {
        $this->app->bind('mailmanager', function ($app)
        {
            return new \App\Libraries\MailManager;
        });

        $this->app->bind('notificationmanager', function ($app)
        {

            return new \App\Libraries\NotificationManager;
        });

        $this->app->bind('nodegwmanager', function ($app)
        {

            return new \App\Libraries\NodeGWManager;
        });

        $this->app->bind('date', function ($app)
        {

            return new \App\Libraries\Date;
        });

        $this->app->bind('wciapi', function ($app)
        {

            return new \App\Libraries\WCIApi;
        });

        $this->app->bind('peakhandler', function ($app)
        {

            return new \App\Libraries\PeakHandler;
        });

        $this->app->bind('datatables', function ($app)
        {

            return new \App\Libraries\DataTables;
        });

    }

    public function provides()
    {
        return ['mailmanager', 'notificationmanager', 'nodegwmanager'];
    }

}